/**
    * @license
    * Copyright 2022 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@tensorflow/tfjs-core'), require('@tensorflow/tfjs-converter')) :
    typeof define === 'function' && define.amd ? define(['exports', '@tensorflow/tfjs-core', '@tensorflow/tfjs-converter'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.depthEstimation = {}, global.tf, global.tf));
})(this, (function (exports, tf, tfconv) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var tf__namespace = /*#__PURE__*/_interopNamespace(tf);
    var tfconv__namespace = /*#__PURE__*/_interopNamespace(tfconv);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    var selfie_segmentation = {};

    (function(){/*

     Copyright The Closure Library Authors.
     SPDX-License-Identifier: Apache-2.0
    */
    var D;function aa(a){var b=0;return function(){return b<a.length?{done:!1,value:a[b++]}:{done:!0}}}var ba="function"==typeof Object.defineProperties?Object.defineProperty:function(a,b,c){if(a==Array.prototype||a==Object.prototype)return a;a[b]=c.value;return a};
    function ca(a){a=["object"==typeof globalThis&&globalThis,a,"object"==typeof window&&window,"object"==typeof self&&self,"object"==typeof commonjsGlobal&&commonjsGlobal];for(var b=0;b<a.length;++b){var c=a[b];if(c&&c.Math==Math)return c}throw Error("Cannot find global object");}var H=ca(this);function J(a,b){if(b)a:{var c=H;a=a.split(".");for(var d=0;d<a.length-1;d++){var f=a[d];if(!(f in c))break a;c=c[f];}a=a[a.length-1];d=c[a];b=b(d);b!=d&&null!=b&&ba(c,a,{configurable:!0,writable:!0,value:b});}}
    J("Symbol",function(a){function b(h){if(this instanceof b)throw new TypeError("Symbol is not a constructor");return new c(d+(h||"")+"_"+f++,h)}function c(h,e){this.g=h;ba(this,"description",{configurable:!0,writable:!0,value:e});}if(a)return a;c.prototype.toString=function(){return this.g};var d="jscomp_symbol_"+(1E9*Math.random()>>>0)+"_",f=0;return b});
    J("Symbol.iterator",function(a){if(a)return a;a=Symbol("Symbol.iterator");for(var b="Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array".split(" "),c=0;c<b.length;c++){var d=H[b[c]];"function"===typeof d&&"function"!=typeof d.prototype[a]&&ba(d.prototype,a,{configurable:!0,writable:!0,value:function(){return da(aa(this))}});}return a});function da(a){a={next:a};a[Symbol.iterator]=function(){return this};return a}
    function M(a){var b="undefined"!=typeof Symbol&&Symbol.iterator&&a[Symbol.iterator];return b?b.call(a):{next:aa(a)}}function ea(a){if(!(a instanceof Array)){a=M(a);for(var b,c=[];!(b=a.next()).done;)c.push(b.value);a=c;}return a}var fa="function"==typeof Object.create?Object.create:function(a){function b(){}b.prototype=a;return new b},ha;
    if("function"==typeof Object.setPrototypeOf)ha=Object.setPrototypeOf;else {var ia;a:{var ja={a:!0},ka={};try{ka.__proto__=ja;ia=ka.a;break a}catch(a){}ia=!1;}ha=ia?function(a,b){a.__proto__=b;if(a.__proto__!==b)throw new TypeError(a+" is not extensible");return a}:null;}var la=ha;
    function ma(a,b){a.prototype=fa(b.prototype);a.prototype.constructor=a;if(la)la(a,b);else for(var c in b)if("prototype"!=c)if(Object.defineProperties){var d=Object.getOwnPropertyDescriptor(b,c);d&&Object.defineProperty(a,c,d);}else a[c]=b[c];a.ea=b.prototype;}function na(){this.l=!1;this.i=null;this.h=void 0;this.g=1;this.s=this.m=0;this.j=null;}function oa(a){if(a.l)throw new TypeError("Generator is already running");a.l=!0;}na.prototype.o=function(a){this.h=a;};
    function pa(a,b){a.j={U:b,V:!0};a.g=a.m||a.s;}na.prototype.return=function(a){this.j={return:a};this.g=this.s;};function N(a,b,c){a.g=c;return {value:b}}function qa(a){this.g=new na;this.h=a;}function ra(a,b){oa(a.g);var c=a.g.i;if(c)return sa(a,"return"in c?c["return"]:function(d){return {value:d,done:!0}},b,a.g.return);a.g.return(b);return ta(a)}
    function sa(a,b,c,d){try{var f=b.call(a.g.i,c);if(!(f instanceof Object))throw new TypeError("Iterator result "+f+" is not an object");if(!f.done)return a.g.l=!1,f;var h=f.value;}catch(e){return a.g.i=null,pa(a.g,e),ta(a)}a.g.i=null;d.call(a.g,h);return ta(a)}function ta(a){for(;a.g.g;)try{var b=a.h(a.g);if(b)return a.g.l=!1,{value:b.value,done:!1}}catch(c){a.g.h=void 0,pa(a.g,c);}a.g.l=!1;if(a.g.j){b=a.g.j;a.g.j=null;if(b.V)throw b.U;return {value:b.return,done:!0}}return {value:void 0,done:!0}}
    function ua(a){this.next=function(b){oa(a.g);a.g.i?b=sa(a,a.g.i.next,b,a.g.o):(a.g.o(b),b=ta(a));return b};this.throw=function(b){oa(a.g);a.g.i?b=sa(a,a.g.i["throw"],b,a.g.o):(pa(a.g,b),b=ta(a));return b};this.return=function(b){return ra(a,b)};this[Symbol.iterator]=function(){return this};}function O(a,b){b=new ua(new qa(b));la&&a.prototype&&la(b,a.prototype);return b}
    function va(a,b){a instanceof String&&(a+="");var c=0,d=!1,f={next:function(){if(!d&&c<a.length){var h=c++;return {value:b(h,a[h]),done:!1}}d=!0;return {done:!0,value:void 0}}};f[Symbol.iterator]=function(){return f};return f}var wa="function"==typeof Object.assign?Object.assign:function(a,b){for(var c=1;c<arguments.length;c++){var d=arguments[c];if(d)for(var f in d)Object.prototype.hasOwnProperty.call(d,f)&&(a[f]=d[f]);}return a};J("Object.assign",function(a){return a||wa});
    J("Promise",function(a){function b(e){this.h=0;this.i=void 0;this.g=[];this.o=!1;var g=this.j();try{e(g.resolve,g.reject);}catch(k){g.reject(k);}}function c(){this.g=null;}function d(e){return e instanceof b?e:new b(function(g){g(e);})}if(a)return a;c.prototype.h=function(e){if(null==this.g){this.g=[];var g=this;this.i(function(){g.l();});}this.g.push(e);};var f=H.setTimeout;c.prototype.i=function(e){f(e,0);};c.prototype.l=function(){for(;this.g&&this.g.length;){var e=this.g;this.g=[];for(var g=0;g<e.length;++g){var k=
    e[g];e[g]=null;try{k();}catch(l){this.j(l);}}}this.g=null;};c.prototype.j=function(e){this.i(function(){throw e;});};b.prototype.j=function(){function e(l){return function(q){k||(k=!0,l.call(g,q));}}var g=this,k=!1;return {resolve:e(this.C),reject:e(this.l)}};b.prototype.C=function(e){if(e===this)this.l(new TypeError("A Promise cannot resolve to itself"));else if(e instanceof b)this.F(e);else {a:switch(typeof e){case "object":var g=null!=e;break a;case "function":g=!0;break a;default:g=!1;}g?this.u(e):this.m(e);}};
    b.prototype.u=function(e){var g=void 0;try{g=e.then;}catch(k){this.l(k);return}"function"==typeof g?this.G(g,e):this.m(e);};b.prototype.l=function(e){this.s(2,e);};b.prototype.m=function(e){this.s(1,e);};b.prototype.s=function(e,g){if(0!=this.h)throw Error("Cannot settle("+e+", "+g+"): Promise already settled in state"+this.h);this.h=e;this.i=g;2===this.h&&this.D();this.A();};b.prototype.D=function(){var e=this;f(function(){if(e.B()){var g=H.console;"undefined"!==typeof g&&g.error(e.i);}},1);};b.prototype.B=
    function(){if(this.o)return !1;var e=H.CustomEvent,g=H.Event,k=H.dispatchEvent;if("undefined"===typeof k)return !0;"function"===typeof e?e=new e("unhandledrejection",{cancelable:!0}):"function"===typeof g?e=new g("unhandledrejection",{cancelable:!0}):(e=H.document.createEvent("CustomEvent"),e.initCustomEvent("unhandledrejection",!1,!0,e));e.promise=this;e.reason=this.i;return k(e)};b.prototype.A=function(){if(null!=this.g){for(var e=0;e<this.g.length;++e)h.h(this.g[e]);this.g=null;}};var h=new c;b.prototype.F=
    function(e){var g=this.j();e.J(g.resolve,g.reject);};b.prototype.G=function(e,g){var k=this.j();try{e.call(g,k.resolve,k.reject);}catch(l){k.reject(l);}};b.prototype.then=function(e,g){function k(w,t){return "function"==typeof w?function(y){try{l(w(y));}catch(m){q(m);}}:t}var l,q,v=new b(function(w,t){l=w;q=t;});this.J(k(e,l),k(g,q));return v};b.prototype.catch=function(e){return this.then(void 0,e)};b.prototype.J=function(e,g){function k(){switch(l.h){case 1:e(l.i);break;case 2:g(l.i);break;default:throw Error("Unexpected state: "+
    l.h);}}var l=this;null==this.g?h.h(k):this.g.push(k);this.o=!0;};b.resolve=d;b.reject=function(e){return new b(function(g,k){k(e);})};b.race=function(e){return new b(function(g,k){for(var l=M(e),q=l.next();!q.done;q=l.next())d(q.value).J(g,k);})};b.all=function(e){var g=M(e),k=g.next();return k.done?d([]):new b(function(l,q){function v(y){return function(m){w[y]=m;t--;0==t&&l(w);}}var w=[],t=0;do w.push(void 0),t++,d(k.value).J(v(w.length-1),q),k=g.next();while(!k.done)})};return b});
    J("Object.is",function(a){return a?a:function(b,c){return b===c?0!==b||1/b===1/c:b!==b&&c!==c}});J("Array.prototype.includes",function(a){return a?a:function(b,c){var d=this;d instanceof String&&(d=String(d));var f=d.length;c=c||0;for(0>c&&(c=Math.max(c+f,0));c<f;c++){var h=d[c];if(h===b||Object.is(h,b))return !0}return !1}});
    J("String.prototype.includes",function(a){return a?a:function(b,c){if(null==this)throw new TypeError("The 'this' value for String.prototype.includes must not be null or undefined");if(b instanceof RegExp)throw new TypeError("First argument to String.prototype.includes must not be a regular expression");return -1!==this.indexOf(b,c||0)}});J("Array.prototype.keys",function(a){return a?a:function(){return va(this,function(b){return b})}});var xa=this||self;
    function ya(a,b){a=a.split(".");var c=xa;a[0]in c||"undefined"==typeof c.execScript||c.execScript("var "+a[0]);for(var d;a.length&&(d=a.shift());)a.length||void 0===b?c[d]&&c[d]!==Object.prototype[d]?c=c[d]:c=c[d]={}:c[d]=b;}function za(a,b){b=String.fromCharCode.apply(null,b);return null==a?b:a+b}var Aa,Ba="undefined"!==typeof TextDecoder,Ca,Da="undefined"!==typeof TextEncoder;
    function Ea(a){if(Da)a=(Ca||(Ca=new TextEncoder)).encode(a);else {var b=void 0;b=void 0===b?!1:b;for(var c=0,d=new Uint8Array(3*a.length),f=0;f<a.length;f++){var h=a.charCodeAt(f);if(128>h)d[c++]=h;else {if(2048>h)d[c++]=h>>6|192;else {if(55296<=h&&57343>=h){if(56319>=h&&f<a.length){var e=a.charCodeAt(++f);if(56320<=e&&57343>=e){h=1024*(h-55296)+e-56320+65536;d[c++]=h>>18|240;d[c++]=h>>12&63|128;d[c++]=h>>6&63|128;d[c++]=h&63|128;continue}else f--;}if(b)throw Error("Found an unpaired surrogate");h=65533;}d[c++]=
    h>>12|224;d[c++]=h>>6&63|128;}d[c++]=h&63|128;}}a=d.subarray(0,c);}return a}var Fa={},Ga=null;function Ha(a,b){void 0===b&&(b=0);Ja();b=Fa[b];for(var c=Array(Math.floor(a.length/3)),d=b[64]||"",f=0,h=0;f<a.length-2;f+=3){var e=a[f],g=a[f+1],k=a[f+2],l=b[e>>2];e=b[(e&3)<<4|g>>4];g=b[(g&15)<<2|k>>6];k=b[k&63];c[h++]=l+e+g+k;}l=0;k=d;switch(a.length-f){case 2:l=a[f+1],k=b[(l&15)<<2]||d;case 1:a=a[f],c[h]=b[a>>2]+b[(a&3)<<4|l>>4]+k+d;}return c.join("")}
    function Ka(a){var b=a.length,c=3*b/4;c%3?c=Math.floor(c):-1!="=.".indexOf(a[b-1])&&(c=-1!="=.".indexOf(a[b-2])?c-2:c-1);var d=new Uint8Array(c),f=0;La(a,function(h){d[f++]=h;});return d.subarray(0,f)}
    function La(a,b){function c(k){for(;d<a.length;){var l=a.charAt(d++),q=Ga[l];if(null!=q)return q;if(!/^[\s\xa0]*$/.test(l))throw Error("Unknown base64 encoding at char: "+l);}return k}Ja();for(var d=0;;){var f=c(-1),h=c(0),e=c(64),g=c(64);if(64===g&&-1===f)break;b(f<<2|h>>4);64!=e&&(b(h<<4&240|e>>2),64!=g&&b(e<<6&192|g));}}
    function Ja(){if(!Ga){Ga={};for(var a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789".split(""),b=["+/=","+/","-_=","-_.","-_"],c=0;5>c;c++){var d=a.concat(b[c].split(""));Fa[c]=d;for(var f=0;f<d.length;f++){var h=d[f];void 0===Ga[h]&&(Ga[h]=f);}}}}var Ma="function"===typeof Uint8Array.prototype.slice,Na;function Oa(a,b,c){return b===c?Na||(Na=new Uint8Array(0)):Ma?a.slice(b,c):new Uint8Array(a.subarray(b,c))}var P=0,Q=0;function Pa(a,b){b=void 0===b?{}:b;b=void 0===b.v?!1:b.v;this.h=null;this.g=this.i=this.j=0;this.l=!1;this.v=b;a&&Qa(this,a);}function Qa(a,b){b=b.constructor===Uint8Array?b:b.constructor===ArrayBuffer?new Uint8Array(b):b.constructor===Array?new Uint8Array(b):b.constructor===String?Ka(b):b instanceof Uint8Array?new Uint8Array(b.buffer,b.byteOffset,b.byteLength):new Uint8Array(0);a.h=b;a.j=0;a.i=a.h.length;a.g=a.j;}Pa.prototype.reset=function(){this.g=this.j;};
    function Ra(a){var b=a.h,c=b[a.g],d=c&127;if(128>c)return a.g+=1,d;c=b[a.g+1];d|=(c&127)<<7;if(128>c)return a.g+=2,d;c=b[a.g+2];d|=(c&127)<<14;if(128>c)return a.g+=3,d;c=b[a.g+3];d|=(c&127)<<21;if(128>c)return a.g+=4,d;c=b[a.g+4];d|=(c&15)<<28;if(128>c)return a.g+=5,d>>>0;a.g+=5;128<=b[a.g++]&&128<=b[a.g++]&&128<=b[a.g++]&&128<=b[a.g++]&&a.g++;return d}
    function R(a){var b=a.h[a.g];var c=a.h[a.g+1];var d=a.h[a.g+2],f=a.h[a.g+3];a.g+=4;c=(b<<0|c<<8|d<<16|f<<24)>>>0;a=2*(c>>31)+1;b=c>>>23&255;c&=8388607;return 255==b?c?NaN:Infinity*a:0==b?a*Math.pow(2,-149)*c:a*Math.pow(2,b-150)*(c+Math.pow(2,23))}var Sa=[];function Ta(){this.g=new Uint8Array(64);this.h=0;}Ta.prototype.push=function(a){if(!(this.h+1<this.g.length)){var b=this.g;this.g=new Uint8Array(Math.ceil(1+2*this.g.length));this.g.set(b);}this.g[this.h++]=a;};Ta.prototype.length=function(){return this.h};Ta.prototype.end=function(){var a=this.g,b=this.h;this.h=0;return Oa(a,0,b)};function S(a,b){for(;127<b;)a.push(b&127|128),b>>>=7;a.push(b);}function Ua(a){var b={},c=void 0===b.N?!1:b.N;this.o={v:void 0===b.v?!1:b.v};this.N=c;b=this.o;Sa.length?(c=Sa.pop(),b&&(c.v=b.v),a&&Qa(c,a),a=c):a=new Pa(a,b);this.g=a;this.m=this.g.g;this.h=this.i=this.l=-1;this.j=!1;}Ua.prototype.reset=function(){this.g.reset();this.h=this.l=-1;};function Va(a){var b=a.g;(b=b.g==b.i)||(b=a.j)||(b=a.g,b=b.l||0>b.g||b.g>b.i);if(b)return !1;a.m=a.g.g;b=Ra(a.g);var c=b&7;if(0!=c&&5!=c&&1!=c&&2!=c&&3!=c&&4!=c)return a.j=!0,!1;a.i=b;a.l=b>>>3;a.h=c;return !0}
    function Wa(a){switch(a.h){case 0:if(0!=a.h)Wa(a);else {for(a=a.g;a.h[a.g]&128;)a.g++;a.g++;}break;case 1:1!=a.h?Wa(a):(a=a.g,a.g+=8);break;case 2:if(2!=a.h)Wa(a);else {var b=Ra(a.g);a=a.g;a.g+=b;}break;case 5:5!=a.h?Wa(a):(a=a.g,a.g+=4);break;case 3:b=a.l;do{if(!Va(a)){a.j=!0;break}if(4==a.h){a.l!=b&&(a.j=!0);break}Wa(a);}while(1);break;default:a.j=!0;}}function Xa(a,b,c){var d=a.g.i,f=Ra(a.g);f=a.g.g+f;a.g.i=f;c(b,a);a.g.g=f;a.g.i=d;return b}
    function Ya(a){var b=Ra(a.g);a=a.g;var c=a.g;a.g+=b;a=a.h;var d;if(Ba)(d=Aa)||(d=Aa=new TextDecoder("utf-8",{fatal:!1})),d=d.decode(a.subarray(c,c+b));else {b=c+b;for(var f=[],h=null,e,g,k;c<b;)e=a[c++],128>e?f.push(e):224>e?c>=b?f.push(65533):(g=a[c++],194>e||128!==(g&192)?(c--,f.push(65533)):f.push((e&31)<<6|g&63)):240>e?c>=b-1?f.push(65533):(g=a[c++],128!==(g&192)||224===e&&160>g||237===e&&160<=g||128!==((d=a[c++])&192)?(c--,f.push(65533)):f.push((e&15)<<12|(g&63)<<6|d&63)):244>=e?c>=b-2?f.push(65533):
    (g=a[c++],128!==(g&192)||0!==(e<<28)+(g-144)>>30||128!==((d=a[c++])&192)||128!==((k=a[c++])&192)?(c--,f.push(65533)):(e=(e&7)<<18|(g&63)<<12|(d&63)<<6|k&63,e-=65536,f.push((e>>10&1023)+55296,(e&1023)+56320))):f.push(65533),8192<=f.length&&(h=za(h,f),f.length=0);d=za(h,f);}return d}function Za(){this.h=[];this.i=0;this.g=new Ta;}function $a(a,b){0!==b.length&&(a.h.push(b),a.i+=b.length);}function ab(a){var b=a.i+a.g.length();if(0===b)return new Uint8Array(0);b=new Uint8Array(b);for(var c=a.h,d=c.length,f=0,h=0;h<d;h++){var e=c[h];0!==e.length&&(b.set(e,f),f+=e.length);}c=a.g;d=c.h;0!==d&&(b.set(c.g.subarray(0,d),f),c.h=0);a.h=[b];return b}
    function T(a,b,c){if(null!=c){S(a.g,8*b+5);a=a.g;var d=c;d=(c=0>d?1:0)?-d:d;0===d?0<1/d?P=Q=0:(Q=0,P=2147483648):isNaN(d)?(Q=0,P=2147483647):3.4028234663852886E38<d?(Q=0,P=(c<<31|2139095040)>>>0):1.1754943508222875E-38>d?(d=Math.round(d/Math.pow(2,-149)),Q=0,P=(c<<31|d)>>>0):(b=Math.floor(Math.log(d)/Math.LN2),d*=Math.pow(2,-b),d=Math.round(8388608*d)&8388607,Q=0,P=(c<<31|b+127<<23|d)>>>0);c=P;a.push(c>>>0&255);a.push(c>>>8&255);a.push(c>>>16&255);a.push(c>>>24&255);}}var bb="function"===typeof Uint8Array;function cb(a,b,c){if(null!=a)return "object"===typeof a?bb&&a instanceof Uint8Array?c(a):db(a,b,c):b(a)}function db(a,b,c){if(Array.isArray(a)){for(var d=Array(a.length),f=0;f<a.length;f++)d[f]=cb(a[f],b,c);Array.isArray(a)&&a.W&&eb(d);return d}d={};for(f in a)d[f]=cb(a[f],b,c);return d}function fb(a){return "number"===typeof a?isFinite(a)?a:String(a):a}var gb={W:{value:!0,configurable:!0}};
    function eb(a){Array.isArray(a)&&!Object.isFrozen(a)&&Object.defineProperties(a,gb);return a}var hb;function U(a,b,c){var d=hb;hb=null;a||(a=d);d=this.constructor.ca;a||(a=d?[d]:[]);this.j=d?0:-1;this.i=null;this.g=a;a:{d=this.g.length;a=d-1;if(d&&(d=this.g[a],null!==d&&"object"===typeof d&&d.constructor===Object)){this.l=a-this.j;this.h=d;break a}void 0!==b&&-1<b?(this.l=Math.max(b,a+1-this.j),this.h=null):this.l=Number.MAX_VALUE;}if(c)for(b=0;b<c.length;b++)a=c[b],a<this.l?(a+=this.j,(d=this.g[a])?eb(d):this.g[a]=ib):(jb(this),(d=this.h[a])?eb(d):this.h[a]=ib);}var ib=Object.freeze(eb([]));
    function jb(a){var b=a.l+a.j;a.g[b]||(a.h=a.g[b]={});}function V(a,b,c){return -1===b?null:(void 0===c?0:c)||b>=a.l?a.h?a.h[b]:void 0:a.g[b+a.j]}function kb(a){var b=void 0===b?!1:b;var c=V(a,1,b);null==c&&(c=ib);c===ib&&(c=eb([]),W(a,1,c,b));return c}function X(a,b,c){a=V(a,b);a=null==a?a:+a;return null==a?void 0===c?0:c:a}function W(a,b,c,d){(void 0===d?0:d)||b>=a.l?(jb(a),a.h[b]=c):a.g[b+a.j]=c;}
    function lb(a,b){a.i||(a.i={});var c=a.i[1];if(!c){var d=kb(a);c=[];for(var f=0;f<d.length;f++)c[f]=new b(d[f]);a.i[1]=c;}return c}function mb(a,b,c,d){var f=lb(a,c);b=b?b:new c;a=kb(a);void 0!=d?(f.splice(d,0,b),a.splice(d,0,nb(b))):(f.push(b),a.push(nb(b)));}U.prototype.toJSON=function(){var a=nb(this);return db(a,fb,Ha)};function nb(a,b){if(a.i)for(var c in a.i){var d=a.i[c];if(Array.isArray(d))for(var f=0;f<d.length;f++)d[f]&&nb(d[f]);else d&&nb(d);}return a.g}
    U.prototype.toString=function(){return nb(this).toString()};function ob(a,b){a=V(a,b);return null==a?0:a}function pb(a,b){a=V(a,b);return null==a?"":a}function qb(a,b){if(a=a.m){$a(b,b.g.end());for(var c=0;c<a.length;c++)$a(b,a[c]);}}function rb(a,b){if(4==b.h)return !1;var c=b.m;Wa(b);b.N||(b=Oa(b.g.h,c,b.g.g),(c=a.m)?c.push(b):a.m=[b]);return !0}function Y(a,b){var c=void 0;return new (c||(c=Promise))(function(d,f){function h(k){try{g(b.next(k));}catch(l){f(l);}}function e(k){try{g(b["throw"](k));}catch(l){f(l);}}function g(k){k.done?d(k.value):(new c(function(l){l(k.value);})).then(h,e);}g((b=b.apply(a,void 0)).next());})}function sb(a){U.call(this,a);}ma(sb,U);function tb(a,b){for(;Va(b);)switch(b.i){case 8:var c=Ra(b.g);W(a,1,c);break;case 21:c=R(b.g);W(a,2,c);break;case 26:c=Ya(b);W(a,3,c);break;case 34:c=Ya(b);W(a,4,c);break;default:if(!rb(a,b))return a}return a}function ub(a){U.call(this,a,-1,vb);}ma(ub,U);ub.prototype.addClassification=function(a,b){mb(this,a,sb,b);};var vb=[1];function wb(a){U.call(this,a);}ma(wb,U);function xb(a,b){for(;Va(b);)switch(b.i){case 13:var c=R(b.g);W(a,1,c);break;case 21:c=R(b.g);W(a,2,c);break;case 29:c=R(b.g);W(a,3,c);break;case 37:c=R(b.g);W(a,4,c);break;case 45:c=R(b.g);W(a,5,c);break;default:if(!rb(a,b))return a}return a}function yb(a){U.call(this,a,-1,zb);}ma(yb,U);var zb=[1];function Ab(a){U.call(this,a);}ma(Ab,U);function Bb(a,b,c){c=a.createShader(0===c?a.VERTEX_SHADER:a.FRAGMENT_SHADER);a.shaderSource(c,b);a.compileShader(c);if(!a.getShaderParameter(c,a.COMPILE_STATUS))throw Error("Could not compile WebGL shader.\n\n"+a.getShaderInfoLog(c));return c}function Cb(a){return lb(a,sb).map(function(b){return {index:ob(b,1),Y:X(b,2),label:null!=V(b,3)?pb(b,3):void 0,displayName:null!=V(b,4)?pb(b,4):void 0}})}function Db(a){return {x:X(a,1),y:X(a,2),z:X(a,3),visibility:null!=V(a,4)?X(a,4):void 0}}function Eb(a,b){this.h=a;this.g=b;this.l=0;}
    function Fb(a,b,c){Gb(a,b);if("function"===typeof a.g.canvas.transferToImageBitmap)return Promise.resolve(a.g.canvas.transferToImageBitmap());if(c)return Promise.resolve(a.g.canvas);if("function"===typeof createImageBitmap)return createImageBitmap(a.g.canvas);void 0===a.i&&(a.i=document.createElement("canvas"));return new Promise(function(d){a.i.height=a.g.canvas.height;a.i.width=a.g.canvas.width;a.i.getContext("2d",{}).drawImage(a.g.canvas,0,0,a.g.canvas.width,a.g.canvas.height);d(a.i);})}
    function Gb(a,b){var c=a.g;if(void 0===a.m){var d=Bb(c,"\n  attribute vec2 aVertex;\n  attribute vec2 aTex;\n  varying vec2 vTex;\n  void main(void) {\n    gl_Position = vec4(aVertex, 0.0, 1.0);\n    vTex = aTex;\n  }",0),f=Bb(c,"\n  precision mediump float;\n  varying vec2 vTex;\n  uniform sampler2D sampler0;\n  void main(){\n    gl_FragColor = texture2D(sampler0, vTex);\n  }",1),h=c.createProgram();c.attachShader(h,d);c.attachShader(h,f);c.linkProgram(h);if(!c.getProgramParameter(h,c.LINK_STATUS))throw Error("Could not compile WebGL program.\n\n"+
    c.getProgramInfoLog(h));d=a.m=h;c.useProgram(d);f=c.getUniformLocation(d,"sampler0");a.j={I:c.getAttribLocation(d,"aVertex"),H:c.getAttribLocation(d,"aTex"),da:f};a.s=c.createBuffer();c.bindBuffer(c.ARRAY_BUFFER,a.s);c.enableVertexAttribArray(a.j.I);c.vertexAttribPointer(a.j.I,2,c.FLOAT,!1,0,0);c.bufferData(c.ARRAY_BUFFER,new Float32Array([-1,-1,-1,1,1,1,1,-1]),c.STATIC_DRAW);c.bindBuffer(c.ARRAY_BUFFER,null);a.o=c.createBuffer();c.bindBuffer(c.ARRAY_BUFFER,a.o);c.enableVertexAttribArray(a.j.H);c.vertexAttribPointer(a.j.H,
    2,c.FLOAT,!1,0,0);c.bufferData(c.ARRAY_BUFFER,new Float32Array([0,1,0,0,1,0,1,1]),c.STATIC_DRAW);c.bindBuffer(c.ARRAY_BUFFER,null);c.uniform1i(f,0);}d=a.j;c.useProgram(a.m);c.canvas.width=b.width;c.canvas.height=b.height;c.viewport(0,0,b.width,b.height);c.activeTexture(c.TEXTURE0);a.h.bindTexture2d(b.glName);c.enableVertexAttribArray(d.I);c.bindBuffer(c.ARRAY_BUFFER,a.s);c.vertexAttribPointer(d.I,2,c.FLOAT,!1,0,0);c.enableVertexAttribArray(d.H);c.bindBuffer(c.ARRAY_BUFFER,a.o);c.vertexAttribPointer(d.H,
    2,c.FLOAT,!1,0,0);c.bindFramebuffer(c.DRAW_FRAMEBUFFER?c.DRAW_FRAMEBUFFER:c.FRAMEBUFFER,null);c.clearColor(0,0,0,0);c.clear(c.COLOR_BUFFER_BIT);c.colorMask(!0,!0,!0,!0);c.drawArrays(c.TRIANGLE_FAN,0,4);c.disableVertexAttribArray(d.I);c.disableVertexAttribArray(d.H);c.bindBuffer(c.ARRAY_BUFFER,null);a.h.bindTexture2d(0);}function Hb(a){this.g=a;}var Ib=new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]);function Jb(a,b){return b+a}function Kb(a,b){window[a]=b;}function Lb(a){var b=document.createElement("script");b.setAttribute("src",a);b.setAttribute("crossorigin","anonymous");return new Promise(function(c){b.addEventListener("load",function(){c();},!1);b.addEventListener("error",function(){c();},!1);document.body.appendChild(b);})}
    function Mb(){return Y(this,function b(){return O(b,function(c){switch(c.g){case 1:return c.m=2,N(c,WebAssembly.instantiate(Ib),4);case 4:c.g=3;c.m=0;break;case 2:return c.m=0,c.j=null,c.return(!1);case 3:return c.return(!0)}})})}
    function Nb(a){this.g=a;this.listeners={};this.j={};this.F={};this.m={};this.s={};this.G=this.o=this.R=!0;this.C=Promise.resolve();this.P="";this.B={};this.locateFile=a&&a.locateFile||Jb;if("object"===typeof window)var b=window.location.pathname.toString().substring(0,window.location.pathname.toString().lastIndexOf("/"))+"/";else if("undefined"!==typeof location)b=location.pathname.toString().substring(0,location.pathname.toString().lastIndexOf("/"))+"/";else throw Error("solutions can only be loaded on a web page or in a web worker");
    this.S=b;if(a.options){b=M(Object.keys(a.options));for(var c=b.next();!c.done;c=b.next()){c=c.value;var d=a.options[c].default;void 0!==d&&(this.j[c]="function"===typeof d?d():d);}}}D=Nb.prototype;D.close=function(){this.i&&this.i.delete();return Promise.resolve()};function Ob(a,b){return void 0===a.g.files?[]:"function"===typeof a.g.files?a.g.files(b):a.g.files}
    function Pb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q,v,w,t,y;return O(c,function(m){switch(m.g){case 1:f=d;if(!d.R)return m.return();h=Ob(d,d.j);return N(m,Mb(),2);case 2:e=m.h;if("object"===typeof window)return Kb("createMediapipeSolutionsWasm",{locateFile:d.locateFile}),Kb("createMediapipeSolutionsPackedAssets",{locateFile:d.locateFile}),l=h.filter(function(u){return void 0!==u.data}),q=h.filter(function(u){return void 0===u.data}),v=Promise.all(l.map(function(u){var x=Qb(f,u.url);if(void 0!==
    u.path){var z=u.path;x=x.then(function(E){f.overrideFile(z,E);return Promise.resolve(E)});}return x})),w=Promise.all(q.map(function(u){return void 0===u.simd||u.simd&&e||!u.simd&&!e?Lb(f.locateFile(u.url,f.S)):Promise.resolve()})).then(function(){return Y(f,function x(){var z,E,F=this;return O(x,function(K){if(1==K.g)return z=window.createMediapipeSolutionsWasm,E=window.createMediapipeSolutionsPackedAssets,N(K,z(E),2);F.h=K.h;K.g=0;})})}),t=function(){return Y(f,function x(){var z=this;return O(x,function(E){z.g.graph&&
    z.g.graph.url?E=N(E,Qb(z,z.g.graph.url),0):(E.g=0,E=void 0);return E})})}(),N(m,Promise.all([w,v,t]),7);if("function"!==typeof importScripts)throw Error("solutions can only be loaded on a web page or in a web worker");g=h.filter(function(u){return void 0===u.simd||u.simd&&e||!u.simd&&!e}).map(function(u){return f.locateFile(u.url,f.S)});importScripts.apply(null,ea(g));return N(m,createMediapipeSolutionsWasm(Module),6);case 6:d.h=m.h;d.l=new OffscreenCanvas(1,1);d.h.canvas=d.l;k=d.h.GL.createContext(d.l,
    {antialias:!1,alpha:!1,ba:"undefined"!==typeof WebGL2RenderingContext?2:1});d.h.GL.makeContextCurrent(k);m.g=4;break;case 7:d.l=document.createElement("canvas");y=d.l.getContext("webgl2",{});if(!y&&(y=d.l.getContext("webgl",{}),!y))return alert("Failed to create WebGL canvas context when passing video frame."),m.return();d.D=y;d.h.canvas=d.l;d.h.createContext(d.l,!0,!0,{});case 4:d.i=new d.h.SolutionWasm,d.R=!1,m.g=0;}})})}
    function Rb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q,v;return O(c,function(w){if(1==w.g){if(d.g.graph&&d.g.graph.url&&d.P===d.g.graph.url)return w.return();d.o=!0;if(!d.g.graph||!d.g.graph.url){w.g=2;return}d.P=d.g.graph.url;return N(w,Qb(d,d.g.graph.url),3)}2!=w.g&&(f=w.h,d.i.loadGraph(f));h=M(Object.keys(d.B));for(e=h.next();!e.done;e=h.next())g=e.value,d.i.overrideFile(g,d.B[g]);d.B={};if(d.g.listeners)for(k=M(d.g.listeners),l=k.next();!l.done;l=k.next())q=l.value,Sb(d,q);v=d.j;d.j=
    {};d.setOptions(v);w.g=0;})})}D.reset=function(){return Y(this,function b(){var c=this;return O(b,function(d){c.i&&(c.i.reset(),c.m={},c.s={});d.g=0;})})};
    D.setOptions=function(a,b){var c=this;if(b=b||this.g.options){for(var d=[],f=[],h={},e=M(Object.keys(a)),g=e.next();!g.done;h={K:h.K,L:h.L},g=e.next()){var k=g.value;k in this.j&&this.j[k]===a[k]||(this.j[k]=a[k],g=b[k],void 0!==g&&(g.onChange&&(h.K=g.onChange,h.L=a[k],d.push(function(l){return function(){return Y(c,function v(){var w,t=this;return O(v,function(y){if(1==y.g)return N(y,l.K(l.L),2);w=y.h;!0===w&&(t.o=!0);y.g=0;})})}}(h))),g.graphOptionXref&&(k={valueNumber:1===g.type?a[k]:0,valueBoolean:0===
    g.type?a[k]:!1,valueString:2===g.type?a[k]:""},g=Object.assign(Object.assign(Object.assign({},{calculatorName:"",calculatorIndex:0}),g.graphOptionXref),k),f.push(g))));}if(0!==d.length||0!==f.length)this.o=!0,this.A=(void 0===this.A?[]:this.A).concat(f),this.u=(void 0===this.u?[]:this.u).concat(d);}};
    function Tb(a){return Y(a,function c(){var d=this,f,h,e,g,k,l,q;return O(c,function(v){switch(v.g){case 1:if(!d.o)return v.return();if(!d.u){v.g=2;break}f=M(d.u);h=f.next();case 3:if(h.done){v.g=5;break}e=h.value;return N(v,e(),4);case 4:h=f.next();v.g=3;break;case 5:d.u=void 0;case 2:if(d.A){g=new d.h.GraphOptionChangeRequestList;k=M(d.A);for(l=k.next();!l.done;l=k.next())q=l.value,g.push_back(q);d.i.changeOptions(g);g.delete();d.A=void 0;}d.o=!1;v.g=0;}})})}
    D.initialize=function(){return Y(this,function b(){var c=this;return O(b,function(d){return 1==d.g?N(d,Pb(c),2):3!=d.g?N(d,Rb(c),3):N(d,Tb(c),0)})})};function Qb(a,b){return Y(a,function d(){var f=this,h,e;return O(d,function(g){if(b in f.F)return g.return(f.F[b]);h=f.locateFile(b,"");e=fetch(h).then(function(k){return k.arrayBuffer()});f.F[b]=e;return g.return(e)})})}D.overrideFile=function(a,b){this.i?this.i.overrideFile(a,b):this.B[a]=b;};D.clearOverriddenFiles=function(){this.B={};this.i&&this.i.clearOverriddenFiles();};
    D.send=function(a,b){return Y(this,function d(){var f=this,h,e,g,k,l,q,v,w,t;return O(d,function(y){switch(y.g){case 1:if(!f.g.inputs)return y.return();h=1E3*(void 0===b||null===b?performance.now():b);return N(y,f.C,2);case 2:return N(y,f.initialize(),3);case 3:e=new f.h.PacketDataList;g=M(Object.keys(a));for(k=g.next();!k.done;k=g.next())if(l=k.value,q=f.g.inputs[l]){a:{var m=f;var u=a[l];switch(q.type){case "video":var x=m.m[q.stream];x||(x=new Eb(m.h,m.D),m.m[q.stream]=x);m=x;0===m.l&&(m.l=m.h.createTexture());
    if("undefined"!==typeof HTMLVideoElement&&u instanceof HTMLVideoElement){var z=u.videoWidth;x=u.videoHeight;}else "undefined"!==typeof HTMLImageElement&&u instanceof HTMLImageElement?(z=u.naturalWidth,x=u.naturalHeight):(z=u.width,x=u.height);x={glName:m.l,width:z,height:x};z=m.g;z.canvas.width=x.width;z.canvas.height=x.height;z.activeTexture(z.TEXTURE0);m.h.bindTexture2d(m.l);z.texImage2D(z.TEXTURE_2D,0,z.RGBA,z.RGBA,z.UNSIGNED_BYTE,u);m.h.bindTexture2d(0);m=x;break a;case "detections":x=m.m[q.stream];
    x||(x=new Hb(m.h),m.m[q.stream]=x);m=x;m.data||(m.data=new m.g.DetectionListData);m.data.reset(u.length);for(x=0;x<u.length;++x){z=u[x];var E=m.data,F=E.setBoundingBox,K=x;var I=z.T;var r=new Ab;W(r,1,I.Z);W(r,2,I.$);W(r,3,I.height);W(r,4,I.width);W(r,5,I.rotation);W(r,6,I.X);var A=I=new Za;T(A,1,V(r,1));T(A,2,V(r,2));T(A,3,V(r,3));T(A,4,V(r,4));T(A,5,V(r,5));var C=V(r,6);if(null!=C&&null!=C){S(A.g,48);var p=A.g,B=C;C=0>B;B=Math.abs(B);var n=B>>>0;B=Math.floor((B-n)/4294967296);B>>>=0;C&&(B=~B>>>
    0,n=(~n>>>0)+1,4294967295<n&&(n=0,B++,4294967295<B&&(B=0)));P=n;Q=B;C=P;for(n=Q;0<n||127<C;)p.push(C&127|128),C=(C>>>7|n<<25)>>>0,n>>>=7;p.push(C);}qb(r,A);I=ab(I);F.call(E,K,I);if(z.O)for(E=0;E<z.O.length;++E)r=z.O[E],A=r.visibility?!0:!1,F=m.data,K=F.addNormalizedLandmark,I=x,r=Object.assign(Object.assign({},r),{visibility:A?r.visibility:0}),A=new wb,W(A,1,r.x),W(A,2,r.y),W(A,3,r.z),r.visibility&&W(A,4,r.visibility),p=r=new Za,T(p,1,V(A,1)),T(p,2,V(A,2)),T(p,3,V(A,3)),T(p,4,V(A,4)),T(p,5,V(A,5)),
    qb(A,p),r=ab(r),K.call(F,I,r);if(z.M)for(E=0;E<z.M.length;++E){F=m.data;K=F.addClassification;I=x;r=z.M[E];A=new sb;W(A,2,r.Y);r.index&&W(A,1,r.index);r.label&&W(A,3,r.label);r.displayName&&W(A,4,r.displayName);p=r=new Za;n=V(A,1);if(null!=n&&null!=n)if(S(p.g,8),C=p.g,0<=n)S(C,n);else {for(B=0;9>B;B++)C.push(n&127|128),n>>=7;C.push(1);}T(p,2,V(A,2));C=V(A,3);null!=C&&(C=Ea(C),S(p.g,26),S(p.g,C.length),$a(p,p.g.end()),$a(p,C));C=V(A,4);null!=C&&(C=Ea(C),S(p.g,34),S(p.g,C.length),$a(p,p.g.end()),$a(p,
    C));qb(A,p);r=ab(r);K.call(F,I,r);}}m=m.data;break a;default:m={};}}v=m;w=q.stream;switch(q.type){case "video":e.pushTexture2d(Object.assign(Object.assign({},v),{stream:w,timestamp:h}));break;case "detections":t=v;t.stream=w;t.timestamp=h;e.pushDetectionList(t);break;default:throw Error("Unknown input config type: '"+q.type+"'");}}f.i.send(e);return N(y,f.C,4);case 4:e.delete(),y.g=0;}})})};
    function Ub(a,b,c){return Y(a,function f(){var h,e,g,k,l,q,v=this,w,t,y,m,u,x,z,E;return O(f,function(F){switch(F.g){case 1:if(!c)return F.return(b);h={};e=0;g=M(Object.keys(c));for(k=g.next();!k.done;k=g.next())l=k.value,q=c[l],"string"!==typeof q&&"texture"===q.type&&void 0!==b[q.stream]&&++e;1<e&&(v.G=!1);w=M(Object.keys(c));k=w.next();case 2:if(k.done){F.g=4;break}t=k.value;y=c[t];if("string"===typeof y)return z=h,E=t,N(F,Vb(v,t,b[y]),14);m=b[y.stream];if("detection_list"===y.type){if(m){var K=
    m.getRectList();for(var I=m.getLandmarksList(),r=m.getClassificationsList(),A=[],C=0;C<K.size();++C){var p=K.get(C);a:{var B=new Ab;for(p=new Ua(p);Va(p);)switch(p.i){case 13:var n=R(p.g);W(B,1,n);break;case 21:n=R(p.g);W(B,2,n);break;case 29:n=R(p.g);W(B,3,n);break;case 37:n=R(p.g);W(B,4,n);break;case 45:n=R(p.g);W(B,5,n);break;case 48:for(var G=p.g,L=128,Ia=0,Z=n=0;4>Z&&128<=L;Z++)L=G.h[G.g++],Ia|=(L&127)<<7*Z;128<=L&&(L=G.h[G.g++],Ia|=(L&127)<<28,n|=(L&127)>>4);if(128<=L)for(Z=0;5>Z&&128<=L;Z++)L=
    G.h[G.g++],n|=(L&127)<<7*Z+3;if(128>L){G=Ia>>>0;L=n>>>0;if(n=L&2147483648)G=~G+1>>>0,L=~L>>>0,0==G&&(L=L+1>>>0);G=4294967296*L+(G>>>0);n=n?-G:G;}else G.l=!0,n=void 0;W(B,6,n);break;default:if(!rb(B,p))break a}}B={Z:X(B,1),$:X(B,2),height:X(B,3),width:X(B,4),rotation:X(B,5,0),X:ob(B,6)};n=I.get(C);a:for(p=new yb,n=new Ua(n);Va(n);)switch(n.i){case 10:G=Xa(n,new wb,xb);mb(p,G,wb,void 0);break;default:if(!rb(p,n))break a}p=lb(p,wb).map(Db);G=r.get(C);a:for(n=new ub,G=new Ua(G);Va(G);)switch(G.i){case 10:n.addClassification(Xa(G,
    new sb,tb));break;default:if(!rb(n,G))break a}B={T:B,O:p,M:Cb(n)};A.push(B);}K=A;}else K=[];h[t]=K;F.g=7;break}if("proto_list"===y.type){if(m){K=Array(m.size());for(I=0;I<m.size();I++)K[I]=m.get(I);m.delete();}else K=[];h[t]=K;F.g=7;break}if(void 0===m){F.g=3;break}if("float_list"===y.type){h[t]=m;F.g=7;break}if("proto"===y.type){h[t]=m;F.g=7;break}if("texture"!==y.type)throw Error("Unknown output config type: '"+y.type+"'");u=v.s[t];u||(u=new Eb(v.h,v.D),v.s[t]=u);return N(F,Fb(u,m,v.G),13);case 13:x=
    F.h,h[t]=x;case 7:y.transform&&h[t]&&(h[t]=y.transform(h[t]));F.g=3;break;case 14:z[E]=F.h;case 3:k=w.next();F.g=2;break;case 4:return F.return(h)}})})}function Vb(a,b,c){return Y(a,function f(){var h=this,e;return O(f,function(g){return "number"===typeof c||c instanceof Uint8Array||c instanceof h.h.Uint8BlobList?g.return(c):c instanceof h.h.Texture2dDataOut?(e=h.s[b],e||(e=new Eb(h.h,h.D),h.s[b]=e),g.return(Fb(e,c,h.G))):g.return(void 0)})})}
    function Sb(a,b){for(var c=b.name||"$",d=[].concat(ea(b.wants)),f=new a.h.StringList,h=M(b.wants),e=h.next();!e.done;e=h.next())f.push_back(e.value);h=a.h.PacketListener.implement({onResults:function(g){for(var k={},l=0;l<b.wants.length;++l)k[d[l]]=g.get(l);var q=a.listeners[c];q&&(a.C=Ub(a,k,b.outs).then(function(v){v=q(v);for(var w=0;w<b.wants.length;++w){var t=k[d[w]];"object"===typeof t&&t.hasOwnProperty&&t.hasOwnProperty("delete")&&t.delete();}v&&(a.C=v);}));}});a.i.attachMultiListener(f,h);f.delete();}
    D.onResults=function(a,b){this.listeners[b||"$"]=a;};ya("Solution",Nb);ya("OptionType",{BOOL:0,NUMBER:1,aa:2,0:"BOOL",1:"NUMBER",2:"STRING"});function Wb(a){void 0===a&&(a=0);switch(a){case 1:return "selfie_segmentation_landscape.tflite";default:return "selfie_segmentation.tflite"}}
    function Xb(a){var b=this;a=a||{};this.g=new Nb({locateFile:a.locateFile,files:function(c){return [{simd:!0,url:"selfie_segmentation_solution_simd_wasm_bin.js"},{simd:!1,url:"selfie_segmentation_solution_wasm_bin.js"},{data:!0,url:Wb(c.modelSelection)}]},graph:{url:"selfie_segmentation.binarypb"},listeners:[{wants:["segmentation_mask","image_transformed"],outs:{image:{type:"texture",stream:"image_transformed"},segmentationMask:{type:"texture",stream:"segmentation_mask"}}}],inputs:{image:{type:"video",
    stream:"input_frames_gpu"}},options:{useCpuInference:{type:0,graphOptionXref:{calculatorType:"InferenceCalculator",fieldName:"use_cpu_inference"},default:"iPad Simulator;iPhone Simulator;iPod Simulator;iPad;iPhone;iPod".split(";").includes(navigator.platform)||navigator.userAgent.includes("Mac")&&"ontouchend"in document},selfieMode:{type:0,graphOptionXref:{calculatorType:"GlScalerCalculator",calculatorIndex:1,fieldName:"flip_horizontal"}},modelSelection:{type:1,graphOptionXref:{calculatorType:"ConstantSidePacketCalculator",
    calculatorName:"ConstantSidePacketCalculatorModelSelection",fieldName:"int_value"},onChange:function(c){return Y(b,function f(){var h,e,g=this,k;return O(f,function(l){if(1==l.g)return h=Wb(c),e="third_party/mediapipe/modules/selfie_segmentation/"+h,N(l,Qb(g.g,h),2);k=l.h;g.g.overrideFile(e,k);return l.return(!0)})})}}}});}D=Xb.prototype;D.close=function(){this.g.close();return Promise.resolve()};D.onResults=function(a){this.g.onResults(a);};
    D.initialize=function(){return Y(this,function b(){var c=this;return O(b,function(d){return N(d,c.g.initialize(),0)})})};D.reset=function(){this.g.reset();};D.send=function(a){return Y(this,function c(){var d=this;return O(c,function(f){return N(f,d.g.send(a),0)})})};D.setOptions=function(a){this.g.setOptions(a);};ya("SelfieSegmentation",Xb);ya("VERSION","0.1.1632777926");}).call(commonjsGlobal);

    /**
        * @license
        * Copyright 2022 Google LLC. All Rights Reserved.
        * Licensed under the Apache License, Version 2.0 (the "License");
        * you may not use this file except in compliance with the License.
        * You may obtain a copy of the License at
        *
        * http://www.apache.org/licenses/LICENSE-2.0
        *
        * Unless required by applicable law or agreed to in writing, software
        * distributed under the License is distributed on an "AS IS" BASIS,
        * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
        * See the License for the specific language governing permissions and
        * limitations under the License.
        * =============================================================================
        */
    var R=function(t,e){return R=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e;}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);},R(t,e)};function F(t,e){function n(){this.constructor=t;}R(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n);}var C=function(){return C=Object.assign||function(t){for(var e,n=1,r=arguments.length;n<r;n++)for(var i in e=arguments[n])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t},C.apply(this,arguments)};function D(t,e,n,r){return new(n||(n=Promise))((function(i,o){function a(t){try{u(r.next(t));}catch(t){o(t);}}function s(t){try{u(r.throw(t));}catch(t){o(t);}}function u(t){var e;t.done?i(t.value):(e=t.value,e instanceof n?e:new n((function(t){t(e);}))).then(a,s);}u((r=r.apply(t,e||[])).next());}))}function B(t,e){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=e.call(t,a);}catch(t){o=[6,t],r=0;}finally{n=i=0;}if(5&o[0])throw o[1];return {value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function L(t){return t instanceof SVGAnimatedLength?t.baseVal.value:t}function z(t){return D(this,void 0,void 0,(function(){var r,i;return B(this,(function(o){switch(o.label){case 0:return r=document.createElement("canvas"),t instanceof tf.Tensor?[4,tf.browser.toPixels(t,r)]:[3,2];case 1:return o.sent(),[3,3];case 2:r.width=L(t.width),r.height=L(t.height),i=r.getContext("2d"),t instanceof ImageData?i.putImageData(t,0,0):i.drawImage(t,0,0),o.label=3;case 3:return [2,r]}}))}))}function W(t){return D(this,void 0,void 0,(function(){var r,i,o,a,s,u;return B(this,(function(f){switch(f.label){case 0:return t instanceof tf.Tensor?(r=t.shape.slice(0,2),i=r[0],o=r[1],a=ImageData.bind,[4,tf.browser.toPixels(t)]):[3,2];case 1:return [2,new(a.apply(ImageData,[void 0,f.sent(),o,i]))];case 2:return s=document.createElement("canvas"),u=s.getContext("2d"),s.width=L(t.width),s.height=L(t.height),u.drawImage(t,0,0),[2,u.getImageData(0,0,s.width,s.height)]}}))}))}function j(t){return D(this,void 0,void 0,(function(){var e,r;return B(this,(function(i){switch(i.label){case 0:return t instanceof SVGImageElement||t instanceof OffscreenCanvas?[4,z(t)]:[3,2];case 1:return r=i.sent(),[3,3];case 2:r=t,i.label=3;case 3:return e=r,[2,tf.browser.fromPixels(e,4)]}}))}))}function V(t){if(t<0||t>=256)throw new Error("Mask value must be in range [0, 255] but got "+t);if(!Number.isInteger(t))throw new Error("Mask value must be an integer but got "+t)}function q(t){var e=t.shape[2],n=tf.argMax(t,2),r=tf.reshape(n,[-1]);return tf.oneHot(r,e)}function N(t,e){return tf.tidy((function(){return tf.cast(tf.greater(t,tf.scalar(e)),"int32")}))}function Q(t,e){var n=e.shape,o=n[0],s=n[1],m=n[2];return tf.tidy((function(){var n=q(e),r=tf.expandDims(tf.range(0,m,1,"int32"),1),g=tf.cast(tf.matMul(n,r),"int32"),v=tf.reshape(g,[o,s]),w=tf.add(v,tf.scalar(1,"int32"));return tf.sub(function(t,e){return tf.mul(t,e)}(w,t),tf.scalar(1,"int32"))}))}var X=function(){function t(t,e){this.model=t,this.outputStride=e;var n=this.model.inputs[0].shape;tf.util.assert(-1===n[1]&&-1===n[2],(function(){return "Input shape ["+n[1]+", "+n[2]+"] must both be equal to or -1"}));}return t.prototype.predict=function(t){var e=this;return tf.tidy((function(){var n=e.preprocessInput(tf.cast(t,"float32")),r=tf.expandDims(n,0),o=e.model.predict(r).map((function(t){return tf.squeeze(t,[0])})),a=e.nameOutputResults(o);return {heatmapScores:tf.sigmoid(a.heatmap),offsets:a.offsets,displacementFwd:a.displacementFwd,displacementBwd:a.displacementBwd,segmentation:a.segmentation,partHeatmaps:a.partHeatmaps,longOffsets:a.longOffsets,partOffsets:a.partOffsets}}))},t.prototype.dispose=function(){this.model.dispose();},t}(),Y=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return F(e,t),e.prototype.preprocessInput=function(t){return tf.tidy((function(){return tf.sub(tf.div(t,127.5),1)}))},e.prototype.nameOutputResults=function(t){return {offsets:t[0],segmentation:t[1],partHeatmaps:t[2],longOffsets:t[3],heatmap:t[4],displacementFwd:t[5],displacementBwd:t[6],partOffsets:t[7]}},e}(X),G=["nose","leftEye","rightEye","leftEar","rightEar","leftShoulder","rightShoulder","leftElbow","rightElbow","leftWrist","rightWrist","leftHip","rightHip","leftKnee","rightKnee","leftAnkle","rightAnkle"],$=G.length,J=G.reduce((function(t,e,n){return t[e]=n,t}),{});[["leftHip","leftShoulder"],["leftElbow","leftShoulder"],["leftElbow","leftWrist"],["leftHip","leftKnee"],["leftKnee","leftAnkle"],["rightHip","rightShoulder"],["rightElbow","rightShoulder"],["rightElbow","rightWrist"],["rightHip","rightKnee"],["rightKnee","rightAnkle"],["leftShoulder","rightShoulder"],["leftHip","rightHip"]].map((function(t){var e=t[0],n=t[1];return [J[e],J[n]]}));function Z(t,e,n){var r=t[0],i=t[1],o=e[0],a=e[1],s=n.top,u=n.bottom;return [a/(n.left+n.right+i),o/(s+u+r)]}function tt(t,e,n,r){return {y:r.get(t,e,n),x:r.get(t,e,n+$)}}function et(t,e,n){var r=tt(t.heatmapY,t.heatmapX,t.id,n),i=r.y,o=r.x;return {x:t.heatmapX*e+o,y:t.heatmapY*e+i}}function nt(t,e,n){return t<e?e:t>n?n:t}function rt(t,e){return {x:t.x+e.x,y:t.y+e.y}}function it(t,e,n){void 0===n&&(n=.3);for(var r=0,i=0,o=0;o<t.length;o++)e.keypoints[o].score>n&&(i+=1,r+=Math.pow(t[o].x-e.keypoints[o].position.x,2)+Math.pow(t[o].y-e.keypoints[o].position.y,2));return 0===i?r=1/0:r/=i,r}function ot(t,e,n,r,i,o,a){for(var s=a[0],u=a[1],f=n(t),l=f.y*r+f.x,c=i[$*(2*l)+e],d=i[$*(2*l+1)+e],h=t.y+c,p=t.x+d,m=0;m<o;m++){h=Math.min(h,s-1);var g=n({x:p=Math.min(p,u-1),y:h}),v=g.y*r+g.x;h+=c=i[$*(2*v)+e],p+=d=i[$*(2*v+1)+e];}return {x:p,y:h}}function at(t,e,n,r,i,o,a,s,u,f){for(var l=i[0],c=i[1],d=o[0],h=o[1],p=s[0],m=s[1],g=[],v=function(t){return function(t,e,n,r){var i=e[0],o=e[1],a=n[0],s=n[1],u=Math.round(((i+t.y+1)*s-1)/r);return {x:Math.round(((o+t.x+1)*a-1)/r),y:u}}(t,[l,c],[d,h],u)},w=0;w<r;w++){var y=ot(t,w,v,a,e,f,[p,m]);g.push(y);}for(var b=-1,S=1/0,x=0;x<n.length;x++){var M=it(g,n[x]);M<S&&(b=x,S=M);}return b}function st(t,e){var n=t[0],r=t[1];return [Math.round((r-1)/e+1),Math.round((n-1)/e+1)]}function ut(t,e,n,r,i,o,a,s,u,f,l){for(var d=a[0],h=a[1],p=t.shape,m=p[0],g=p[1],v=e.shape.slice(0,2),w=v[0],y=v[1],x=tf.reshape(e,[w,y,2,$]),M=new Float32Array(l*$*3).fill(0),k=0;k<n.length;k++)for(var E=k*$*3,T=n[k],P=0;P<$;P++){var I=T.keypoints[P],O=E+3*P;M[O]=I.score,M[O+1]=I.position.y,M[O+2]=I.position.x;}var _=Z([r,i],[d,h],s),H=_[0],A=_[1],R=tf.tensor(M,[l,$,3]),F=s.top,C=s.left,D={variableNames:["segmentation","longOffsets","poses"],outputShape:[m,g],userCode:"\n    int convertToPositionInOutput(int pos, int pad, float scale, int stride) {\n      return round(((float(pos + pad) + 1.0) * scale - 1.0) / float(stride));\n    }\n\n    float convertToPositionInOutputFloat(\n        int pos, int pad, float scale, int stride) {\n      return ((float(pos + pad) + 1.0) * scale - 1.0) / float(stride);\n    }\n\n    float dist(float x1, float y1, float x2, float y2) {\n      return pow(x1 - x2, 2.0) + pow(y1 - y2, 2.0);\n    }\n\n    float sampleLongOffsets(float h, float w, int d, int k) {\n      float fh = fract(h);\n      float fw = fract(w);\n      int clH = int(ceil(h));\n      int clW = int(ceil(w));\n      int flH = int(floor(h));\n      int flW = int(floor(w));\n      float o11 = getLongOffsets(flH, flW, d, k);\n      float o12 = getLongOffsets(flH, clW, d, k);\n      float o21 = getLongOffsets(clH, flW, d, k);\n      float o22 = getLongOffsets(clH, clW, d, k);\n      float o1 = mix(o11, o12, fw);\n      float o2 = mix(o21, o22, fw);\n      return mix(o1, o2, fh);\n    }\n\n    int findNearestPose(int h, int w) {\n      float prob = getSegmentation(h, w);\n      if (prob < 1.0) {\n        return -1;\n      }\n\n      // Done(Tyler): convert from output space h/w to strided space.\n      float stridedH = convertToPositionInOutputFloat(\n        h, "+F+", "+A+", "+o+");\n      float stridedW = convertToPositionInOutputFloat(\n        w, "+C+", "+H+", "+o+");\n\n      float minDist = 1000000.0;\n      int iMin = -1;\n      for (int i = 0; i < "+l+"; i++) {\n        float curDistSum = 0.0;\n        int numKpt = 0;\n        for (int k = 0; k < "+$+"; k++) {\n          float dy = sampleLongOffsets(stridedH, stridedW, 0, k);\n          float dx = sampleLongOffsets(stridedH, stridedW, 1, k);\n\n          float y = float(h) + dy;\n          float x = float(w) + dx;\n\n          for (int s = 0; s < "+u+"; s++) {\n            int yRounded = round(min(y, float("+(r-1)+")));\n            int xRounded = round(min(x, float("+(i-1)+")));\n\n            float yStrided = convertToPositionInOutputFloat(\n              yRounded, "+F+", "+A+", "+o+");\n            float xStrided = convertToPositionInOutputFloat(\n              xRounded, "+C+", "+H+", "+o+");\n\n            float dy = sampleLongOffsets(yStrided, xStrided, 0, k);\n            float dx = sampleLongOffsets(yStrided, xStrided, 1, k);\n\n            y = y + dy;\n            x = x + dx;\n          }\n\n          float poseScore = getPoses(i, k, 0);\n          float poseY = getPoses(i, k, 1);\n          float poseX = getPoses(i, k, 2);\n          if (poseScore > "+f+") {\n            numKpt = numKpt + 1;\n            curDistSum = curDistSum + dist(x, y, poseX, poseY);\n          }\n        }\n        if (numKpt > 0 && curDistSum / float(numKpt) < minDist) {\n          minDist = curDistSum / float(numKpt);\n          iMin = i;\n        }\n      }\n      return iMin;\n    }\n\n    void main() {\n        ivec2 coords = getOutputCoords();\n        int nearestPose = findNearestPose(coords[0], coords[1]);\n        setOutput(float(nearestPose));\n      }\n  "};return tf.backend().compileAndRun(D,[t,x,R])}function ft(){return "webgl"===tf.getBackend()}function lt(t,e,n,o,s,u,f,l,c,d,h,p){var m=f[0],g=f[1];return void 0===c&&(c=.2),void 0===d&&(d=8),void 0===h&&(h=.3),void 0===p&&(p=10),D(this,void 0,void 0,(function(){var f,v,w,y,b;return B(this,(function(S){switch(S.label){case 0:return f=n.filter((function(t){return t.score>=c})),ft()?(w=tf.tidy((function(){var n=ut(t,e,f,o,s,u,[m,g],l,d,h,p),c=tf.engine().makeTensorFromDataId(n.dataId,n.shape,n.dtype);return f.map((function(t,e){return function(t,e){return tf.tidy((function(){return tf.cast(tf.equal(t,tf.scalar(e)),"int32")}))}(c,e)}))})),[4,Promise.all(w.map((function(t){return t.data()})))]):[3,2];case 1:return v=S.sent(),w.forEach((function(t){return t.dispose()})),[3,5];case 2:return [4,t.data()];case 3:return y=S.sent(),[4,e.data()];case 4:b=S.sent(),v=function(t,e,n,r,i,o,a,s,u,f){var l=a[0],c=a[1];void 0===f&&(f=5);for(var d=n.map((function(t){return new Uint8Array(r*i).fill(0)})),h=s.top,p=s.left,m=Z([r,i],[l,c],s),g=m[0],v=m[1],w=st([l,c],o)[0],y=0;y<r;y+=1)for(var b=0;b<i;b+=1){var S=y*i+b;if(1===t[S]){var x=at({x:b,y:y},e,n,f,[h,p],[g,v],w,[r,i],o,u);x>=0&&(d[x][S]=1);}}return d}(y,b,f,o,s,u,[m,g],l,d),S.label=5;case 5:return [2,v.map((function(t,e){return {data:t,pose:f[e],width:s,height:o}}))]}}))}))}function ct(t,e,n,o,s,u,f,l,c,m,g,v,w){var y=l[0],b=l[1];return void 0===m&&(m=.2),void 0===g&&(g=8),void 0===v&&(v=.3),void 0===w&&(w=10),D(this,void 0,void 0,(function(){var l,S,x,E,T,P;return B(this,(function(I){switch(I.label){case 0:return l=o.filter((function(t){return t.score>=m})),ft()?(x=tf.tidy((function(){var o=ut(t,e,l,s,u,f,[y,b],c,g,v,w),m=tf.engine().makeTensorFromDataId(o.dataId,o.shape,o.dtype);return l.map((function(t,e){return function(t,e,n){return tf.tidy((function(){return tf.sub(tf.mul(tf.cast(tf.equal(t,tf.scalar(n)),"int32"),tf.add(e,1)),1)}))}(m,n,e)}))})),[4,Promise.all(x.map((function(t){return t.data()})))]):[3,2];case 1:return S=I.sent(),x.forEach((function(t){return t.dispose()})),[3,6];case 2:return [4,t.data()];case 3:return E=I.sent(),[4,e.data()];case 4:return T=I.sent(),[4,n.data()];case 5:P=I.sent(),S=function(t,e,n,r,i,o,a,s,u,f,l){var c=s[0],d=s[1];void 0===l&&(l=5);for(var h=r.map((function(t){return new Int32Array(i*o).fill(-1)})),p=u.top,m=u.left,g=Z([i,o],[c,d],u),v=g[0],w=g[1],y=st([c,d],a)[0],b=0;b<i;b+=1)for(var S=0;S<o;S+=1){var x=b*o+S;if(1===t[x]){var M=at({x:S,y:b},e,r,l,[p,m],[v,w],y,[i,o],a,f);M>=0&&(h[M][x]=n[x]);}}return h}(E,T,P,l,s,u,f,[y,b],c,g),I.label=6;case 6:return [2,S.map((function(t,e){return {pose:l[e],data:t,height:s,width:u}}))]}}))}))}function dt(t){return Math.floor(t/2)}var ht=function(){function t(t,e){this.priorityQueue=new Array(t),this.numberOfElements=-1,this.getElementValue=e;}return t.prototype.enqueue=function(t){this.priorityQueue[++this.numberOfElements]=t,this.swim(this.numberOfElements);},t.prototype.dequeue=function(){var t=this.priorityQueue[0];return this.exchange(0,this.numberOfElements--),this.sink(0),this.priorityQueue[this.numberOfElements+1]=null,t},t.prototype.empty=function(){return -1===this.numberOfElements},t.prototype.size=function(){return this.numberOfElements+1},t.prototype.all=function(){return this.priorityQueue.slice(0,this.numberOfElements+1)},t.prototype.max=function(){return this.priorityQueue[0]},t.prototype.swim=function(t){for(;t>0&&this.less(dt(t),t);)this.exchange(t,dt(t)),t=dt(t);},t.prototype.sink=function(t){for(;2*t<=this.numberOfElements;){var e=2*t;if(e<this.numberOfElements&&this.less(e,e+1)&&e++,!this.less(t,e))break;this.exchange(t,e),t=e;}},t.prototype.getValueAt=function(t){return this.getElementValue(this.priorityQueue[t])},t.prototype.less=function(t,e){return this.getValueAt(t)<this.getValueAt(e)},t.prototype.exchange=function(t,e){var n=this.priorityQueue[t];this.priorityQueue[t]=this.priorityQueue[e],this.priorityQueue[e]=n;},t}();function pt(t,e,n,r,i,o){for(var a=o.shape,s=a[0],u=a[1],f=!0,l=Math.max(n-i,0),c=Math.min(n+i+1,s),d=l;d<c;++d){for(var h=Math.max(r-i,0),p=Math.min(r+i+1,u),m=h;m<p;++m)if(o.get(d,m,t)>e){f=!1;break}if(!f)break}return f}var mt=[["nose","leftEye"],["leftEye","leftEar"],["nose","rightEye"],["rightEye","rightEar"],["nose","leftShoulder"],["leftShoulder","leftElbow"],["leftElbow","leftWrist"],["leftShoulder","leftHip"],["leftHip","leftKnee"],["leftKnee","leftAnkle"],["nose","rightShoulder"],["rightShoulder","rightElbow"],["rightElbow","rightWrist"],["rightShoulder","rightHip"],["rightHip","rightKnee"],["rightKnee","rightAnkle"]].map((function(t){var e=t[0],n=t[1];return [J[e],J[n]]})),gt=mt.map((function(t){return t[1]})),vt=mt.map((function(t){return t[0]}));function wt(t,e,n,r){return {y:nt(Math.round(t.y/e),0,n-1),x:nt(Math.round(t.x/e),0,r-1)}}function yt(t,e,n,r,i,o,a,s){void 0===s&&(s=2);for(var u=r.shape,f=u[0],l=u[1],c=function(t,e,n){var r=n.shape[2]/2;return {y:n.get(e.y,e.x,t),x:n.get(e.y,e.x,r+t)}}(t,wt(e.position,o,f,l),a),d=rt(e.position,c),h=0;h<s;h++){var p=wt(d,o,f,l),m=tt(p.y,p.x,n,i);d=rt({x:p.x*o,y:p.y*o},{x:m.x,y:m.y});}var g=wt(d,o,f,l),v=r.get(g.y,g.x,n);return {position:d,part:G[n],score:v}}function bt(t,e,n,r,i,o){var a=e.shape[2],s=gt.length,u=new Array(a),f=t.part,l=t.score,c=et(f,r,n);u[f.id]={score:l,part:G[f.id],position:c};for(var d=s-1;d>=0;--d){var h=gt[d],p=vt[d];u[h]&&!u[p]&&(u[p]=yt(d,u[h],p,e,n,r,o));}for(d=0;d<s;++d){h=vt[d],p=gt[d];u[h]&&!u[p]&&(u[p]=yt(d,u[h],p,e,n,r,i));}return u}function St(t,e,n,r){var i=n.x,o=n.y;return t.some((function(t){var n,a,s,u,f,l,c=t.keypoints[r].position;return n=o,a=i,s=c.y,u=c.x,(f=s-n)*f+(l=u-a)*l<=e}))}function xt(t,e,n){var r=n.reduce((function(n,r,i){var o=r.position,a=r.score;return St(t,e,o,i)||(n+=a),n}),0);return r/n.length}function Mt(t,e,n,r,i,o,a,s){void 0===a&&(a=.5),void 0===s&&(s=20);for(var u=[],f=function(t,e,n){for(var r=n.shape,i=r[0],o=r[1],a=r[2],s=new ht(i*o*a,(function(t){return t.score})),u=0;u<i;++u)for(var f=0;f<o;++f)for(var l=0;l<a;++l){var c=n.get(u,f,l);c<t||pt(l,c,u,f,e,n)&&s.enqueue({score:c,part:{heatmapY:u,heatmapX:f,id:l}});}return s}(a,1,t),l=s*s;u.length<o&&!f.empty();){var c=f.dequeue();if(!St(u,l,et(c.part,i,e),c.part.id)){var d=bt(c,t,e,i,n,r),h=xt(u,l,d);u.push({keypoints:d,score:h});}}return u}var kt,Et=[-123.15,-115.9,-103.06],Tt=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return F(e,t),e.prototype.preprocessInput=function(t){return tf.add(t,Et)},e.prototype.nameOutputResults=function(t){var e=t[0],n=t[1],r=t[2],i=t[3],o=t[4],a=t[5];return {offsets:o,segmentation:t[6],partHeatmaps:a,longOffsets:i,heatmap:r,displacementFwd:n,displacementBwd:e,partOffsets:t[7]}},e}(X),Pt="https://storage.googleapis.com/tfjs-models/savedmodel/bodypix/resnet50/",It="https://storage.googleapis.com/tfjs-models/savedmodel/bodypix/mobilenet/";function Ot(t){if("undefined"!=typeof HTMLCanvasElement&&t instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&t instanceof OffscreenCanvas||"undefined"!=typeof HTMLImageElement&&t instanceof HTMLImageElement)return function(t){if("offsetHeight"in t&&0!==t.offsetHeight&&"offsetWidth"in t&&0!==t.offsetWidth)return [t.offsetHeight,t.offsetWidth];if(null!=t.height&&null!=t.width)return [t.height,t.width];throw new Error("HTMLImageElement must have height and width attributes set.")}(t);if("undefined"!=typeof ImageData&&t instanceof ImageData)return [t.height,t.width];if("undefined"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement)return function(t){return t.hasAttribute("height")&&t.hasAttribute("width")?[t.height,t.width]:[t.videoHeight,t.videoWidth]}(t);if(t instanceof tf.Tensor)return [t.shape[0],t.shape[1]];throw new Error("error: Unknown input type: "+t+".")}function _t(t,e){return function(t,e){return (t-1)%e==0}(t,e)?t:Math.floor(t/e)*e+1}var Ht={low:"low",medium:"medium",high:"high",full:"full"},At=((kt={})[Ht.low]=.25,kt[Ht.medium]=.5,kt[Ht.high]=.75,kt[Ht.full]=1,kt);function Rt(t,e,n){var r=n[0],i=n[1],o=function(t){if("string"==typeof t){var e=At[t];return tf.util.assert("number"==typeof e,(function(){return "string value of inputResolution must be one of "+Object.values(Ht).join(",")+" but was "+t+"."})),e}return tf.util.assert("number"==typeof t&&t<=2&&t>=.1,(function(){return "inputResolution must be a string or number between 0.1 and 2, but was "+t})),t}(t);return [_t(r*o,e),_t(i*o,e)]}function Ft(t,e,n,i,o){var a=e[0],s=e[1],f=n[0],l=n[1],c=i[0],d=c[0],h=c[1],p=i[1],m=p[0],w=p[1];return void 0===o&&(o=!1),tf.tidy((function(){var e=tf.image.resizeBilinear(t,[f,l],!0);return o&&(e=tf.sigmoid(e)),function(t,e,n){var i=e[0],o=e[1],a=n[0],s=a[0],f=a[1],l=n[1],c=l[0],d=l[1];return tf.tidy((function(){var e=tf.expandDims(t);return tf.squeeze(tf.image.cropAndResize(e,[[s/(i+s+f-1),c/(o+c+d-1),(s+i-1)/(i+s+f-1),(c+o-1)/(o+c+d-1)]],[0],[i,o]),[0])}))}(e,[a,s],[[d,h],[m,w]])}))}function Ct(t,i){var o=i[0],a=i[1],s=Ot(t),u=s[0],f=s[1],l=a/o,c=[0,0,0,0],d=c[0],h=c[1],p=c[2],m=c[3];f/u<l?(d=0,h=0,p=Math.round(.5*(l*u-f)),m=Math.round(.5*(l*u-f))):(d=Math.round(.5*(1/l*f-u)),h=Math.round(.5*(1/l*f-u)),p=0,m=0);var g=tf.tidy((function(){var r=function(t){return t instanceof tf.Tensor?t:tf.browser.fromPixels(t)}(t);return r=tf.pad3d(r,[[d,h],[p,m],[0,0]]),tf.image.resizeBilinear(r,[o,a])}));return {resized:g,padding:{top:d,left:p,right:m,bottom:h}}}function Dt(t){return D(this,void 0,void 0,(function(){return B(this,(function(e){return [2,Promise.all(t.map((function(t){return t.buffer()})))]}))}))}function Bt(t,e,n,r,i){var o=e[0],a=e[1],s=n[0],u=n[1],f=function(t,e,n,r,i){return void 0===r&&(r=0),void 0===i&&(i=0),1===n&&1===e&&0===r&&0===i?t:t.map((function(t){return function(t,e,n,r,i){return void 0===r&&(r=0),void 0===i&&(i=0),{score:t.score,keypoints:t.keypoints.map((function(t){var o=t.score,a=t.part,s=t.position;return {score:o,part:a,position:{x:s.x*n+i,y:s.y*e+r}}}))}}(t,e,n,r,i)}))}(t,(o+r.top+r.bottom)/s,(a+r.left+r.right)/u,-r.top,-r.left);return i?function(t,e){return e<=0?t:t.map((function(t){return function(t,e){return {score:t.score,keypoints:t.keypoints.map((function(t){var n=t.score,r=t.part,i=t.position;return {score:n,part:r,position:{x:e-1-i.x,y:i.y}}}))}}(t,e)}))}(f,a):f}var Lt={architecture:"MobileNetV1",outputStride:16,quantBytes:4,multiplier:.75},zt=["MobileNetV1","ResNet50"],Wt={MobileNetV1:[8,16,32],ResNet50:[32,16]},jt={MobileNetV1:[.5,.75,1],ResNet50:[1]},Vt=[1,2,4];var Kt={flipHorizontal:!1,internalResolution:"medium",segmentationThreshold:.7,maxDetections:10,scoreThreshold:.4,nmsRadius:20},Ut={flipHorizontal:!1,internalResolution:"medium",segmentationThreshold:.7,maxDetections:10,scoreThreshold:.4,nmsRadius:20,minKeypointScore:.3,refineSteps:10};function qt(t){var e=t.segmentationThreshold,n=t.maxDetections,r=t.scoreThreshold,i=t.nmsRadius;if(e<0||e>1)throw new Error("segmentationThreshold "+e+". Should be in range [0.0, 1.0]");if(n<=0)throw new Error("Invalid maxDetections "+n+". Should be > 0");if(r<0||r>1)throw new Error("Invalid scoreThreshold "+r+". Should be in range [0.0, 1.0]");if(i<=0)throw new Error("Invalid nmsRadius "+i+".")}function Nt(t){var e=t.segmentationThreshold,n=t.maxDetections,r=t.scoreThreshold,i=t.nmsRadius,o=t.minKeypointScore,a=t.refineSteps;if(e<0||e>1)throw new Error("segmentationThreshold "+e+". Should be in range [0.0, 1.0]");if(n<=0)throw new Error("Invalid maxDetections "+n+". Should be > 0");if(r<0||r>1)throw new Error("Invalid scoreThreshold "+r+". Should be in range [0.0, 1.0]");if(i<=0)throw new Error("Invalid nmsRadius "+i+".");if(o<0||o>1)throw new Error("Invalid minKeypointScore "+o+".Should be in range [0.0, 1.0]");if(a<=0||a>20)throw new Error("Invalid refineSteps "+a+".Should be in range [1, 20]")}var Qt=function(){function t(t){this.baseModel=t;}return t.prototype.predictForPersonSegmentation=function(t){var e=this.baseModel.predict(t);return {segmentLogits:e.segmentation,heatmapScores:e.heatmapScores,offsets:e.offsets,displacementFwd:e.displacementFwd,displacementBwd:e.displacementBwd}},t.prototype.predictForPersonSegmentationAndPart=function(t){var e=this.baseModel.predict(t);return {segmentLogits:e.segmentation,partHeatmapLogits:e.partHeatmaps,heatmapScores:e.heatmapScores,offsets:e.offsets,displacementFwd:e.displacementFwd,displacementBwd:e.displacementBwd}},t.prototype.predictForMultiPersonInstanceSegmentationAndPart=function(t){var e=this.baseModel.predict(t);return {segmentLogits:e.segmentation,longOffsets:e.longOffsets,heatmapScores:e.heatmapScores,offsets:e.offsets,displacementFwd:e.displacementFwd,displacementBwd:e.displacementBwd,partHeatmaps:e.partHeatmaps}},t.prototype.segmentPersonActivation=function(t,e,n){var i=this;void 0===n&&(n=.5);var o=Ot(t),a=o[0],s=o[1],u=Rt(e,this.baseModel.outputStride,[a,s]),f=Ct(t,u),l=f.resized,c=f.padding,d=tf.tidy((function(){var t=i.predictForPersonSegmentation(l),e=t.segmentLogits,r=t.heatmapScores,o=t.offsets,u=t.displacementFwd,f=t.displacementBwd,d=l.shape,h=d[0],p=d[1],m=Ft(e,[a,s],[h,p],[[c.top,c.bottom],[c.left,c.right]],true);return {segmentation:N(tf.squeeze(m),n),heatmapScores:r,offsets:o,displacementFwd:u,displacementBwd:f}})),h=d.segmentation,p=d.heatmapScores,m=d.offsets,v=d.displacementFwd,w=d.displacementBwd;return l.dispose(),{segmentation:h,heatmapScores:p,offsets:m,displacementFwd:v,displacementBwd:w,padding:c,internalResolutionHeightAndWidth:u}},t.prototype.segmentPerson=function(t,e){return void 0===e&&(e=Kt),D(this,void 0,void 0,(function(){var n,r,i,o,a,s,u,f,l,c,d,h,p,m,g,v,w,y;return B(this,(function(b){switch(b.label){case 0:return qt(e=C(C({},Kt),e)),n=this.segmentPersonActivation(t,e.internalResolution,e.segmentationThreshold),r=n.segmentation,i=n.heatmapScores,o=n.offsets,a=n.displacementFwd,s=n.displacementBwd,u=n.padding,f=n.internalResolutionHeightAndWidth,l=r.shape,c=l[0],d=l[1],[4,r.data()];case 1:return h=b.sent(),r.dispose(),[4,Dt([i,o,a,s])];case 2:return p=b.sent(),m=p[0],g=p[1],v=p[2],w=p[3],y=Bt(y=Mt(m,g,v,w,this.baseModel.outputStride,e.maxDetections,e.scoreThreshold,e.nmsRadius),[c,d],f,u,false),i.dispose(),o.dispose(),a.dispose(),s.dispose(),[2,{height:c,width:d,data:h,allPoses:y}]}}))}))},t.prototype.segmentMultiPerson=function(t,e){return void 0===e&&(e=Ut),D(this,void 0,void 0,(function(){var n,i,o,a,s,u,f,l,c,d,h,p,m,v,w,y,b,S,x,M,k,E=this;return B(this,(function(T){switch(T.label){case 0:return Nt(e=C(C({},Ut),e)),n=Ot(t),i=n[0],o=n[1],a=Rt(e.internalResolution,this.baseModel.outputStride,[i,o]),s=Ct(t,a),u=s.resized,f=s.padding,l=tf.tidy((function(){var t,n=E.predictForMultiPersonInstanceSegmentationAndPart(u),r=n.segmentLogits,s=n.longOffsets,l=n.heatmapScores,c=n.offsets,d=n.displacementFwd,h=n.displacementBwd,p=Ft(r,[i,o],a,[[f.top,f.bottom],[f.left,f.right]],true);return t=s,{segmentation:N(tf.squeeze(p),e.segmentationThreshold),longOffsets:t,heatmapScoresRaw:l,offsetsRaw:c,displacementFwdRaw:d,displacementBwdRaw:h}})),c=l.segmentation,d=l.longOffsets,h=l.heatmapScoresRaw,p=l.offsetsRaw,m=l.displacementFwdRaw,v=l.displacementBwdRaw,[4,Dt([h,p,m,v])];case 1:return w=T.sent(),y=w[0],b=w[1],S=w[2],x=w[3],M=Bt(M=Mt(y,b,S,x,this.baseModel.outputStride,e.maxDetections,e.scoreThreshold,e.nmsRadius),[i,o],a,f,false),[4,lt(c,d,M,i,o,this.baseModel.outputStride,a,f,e.scoreThreshold,e.refineSteps,e.minKeypointScore,e.maxDetections)];case 2:return k=T.sent(),u.dispose(),c.dispose(),d.dispose(),h.dispose(),p.dispose(),m.dispose(),v.dispose(),[2,k]}}))}))},t.prototype.segmentPersonPartsActivation=function(t,e,n){var i=this;void 0===n&&(n=.5);var o=Ot(t),a=o[0],s=o[1],u=Rt(e,this.baseModel.outputStride,[a,s]),f=Ct(t,u),l=f.resized,c=f.padding,d=tf.tidy((function(){var t=i.predictForPersonSegmentationAndPart(l),e=t.segmentLogits,r=t.partHeatmapLogits,o=t.heatmapScores,u=t.offsets,f=t.displacementFwd,d=t.displacementBwd,h=l.shape,p=h[0],m=h[1],v=Ft(e,[a,s],[p,m],[[c.top,c.bottom],[c.left,c.right]],true),w=Ft(r,[a,s],[p,m],[[c.top,c.bottom],[c.left,c.right]],true);return {partSegmentation:Q(N(tf.squeeze(v),n),w),heatmapScores:o,offsets:u,displacementFwd:f,displacementBwd:d}})),h=d.partSegmentation,p=d.heatmapScores,m=d.offsets,v=d.displacementFwd,w=d.displacementBwd;return l.dispose(),{partSegmentation:h,heatmapScores:p,offsets:m,displacementFwd:v,displacementBwd:w,padding:c,internalResolutionHeightAndWidth:u}},t.prototype.segmentPersonParts=function(t,e){return void 0===e&&(e=Kt),D(this,void 0,void 0,(function(){var n,r,i,o,a,s,u,f,l,c,d,h,p,m,g,v,w,y;return B(this,(function(b){switch(b.label){case 0:return qt(e=C(C({},Kt),e)),n=this.segmentPersonPartsActivation(t,e.internalResolution,e.segmentationThreshold),r=n.partSegmentation,i=n.heatmapScores,o=n.offsets,a=n.displacementFwd,s=n.displacementBwd,u=n.padding,f=n.internalResolutionHeightAndWidth,l=r.shape,c=l[0],d=l[1],[4,r.data()];case 1:return h=b.sent(),r.dispose(),[4,Dt([i,o,a,s])];case 2:return p=b.sent(),m=p[0],g=p[1],v=p[2],w=p[3],y=Bt(y=Mt(m,g,v,w,this.baseModel.outputStride,e.maxDetections,e.scoreThreshold,e.nmsRadius),[c,d],f,u,false),i.dispose(),o.dispose(),a.dispose(),s.dispose(),[2,{height:c,width:d,data:h,allPoses:y}]}}))}))},t.prototype.segmentMultiPersonParts=function(t,e){return void 0===e&&(e=Ut),D(this,void 0,void 0,(function(){var n,o,a,s,d,h,p,m,v,w,y,b,S,x,M,k,E,T,P,I,O,_,H=this;return B(this,(function(A){switch(A.label){case 0:return Nt(e=C(C({},Ut),e)),n=Ot(t),o=n[0],a=n[1],s=Rt(e.internalResolution,this.baseModel.outputStride,[o,a]),d=Ct(t,s),h=d.resized,p=d.padding,m=tf.tidy((function(){var t=H.predictForMultiPersonInstanceSegmentationAndPart(h),n=t.segmentLogits,d=t.longOffsets,m=t.heatmapScores,v=t.offsets,w=t.displacementFwd,y=t.displacementBwd,b=t.partHeatmaps,S=Ft(n,[o,a],s,[[p.top,p.bottom],[p.left,p.right]],true),x=Ft(b,[o,a],s,[[p.top,p.bottom],[p.left,p.right]],true),M=d,k=N(tf.squeeze(S),e.segmentationThreshold),E=function(t){var e=t.shape,n=e[0],o=e[1],a=e[2];return tf.tidy((function(){var e=q(t),r=tf.expandDims(tf.range(0,a,1,"int32"),1),s=tf.cast(tf.matMul(e,r),"int32");return tf.reshape(s,[n,o])}))}(x);return {segmentation:k,longOffsets:M,heatmapScoresRaw:m,offsetsRaw:v,displacementFwdRaw:w,displacementBwdRaw:y,partSegmentation:E}})),v=m.segmentation,w=m.longOffsets,y=m.heatmapScoresRaw,b=m.offsetsRaw,S=m.displacementFwdRaw,x=m.displacementBwdRaw,M=m.partSegmentation,[4,Dt([y,b,S,x])];case 1:return k=A.sent(),E=k[0],T=k[1],P=k[2],I=k[3],O=Bt(O=Mt(E,T,P,I,this.baseModel.outputStride,e.maxDetections,e.scoreThreshold,e.nmsRadius),[o,a],s,p,false),[4,ct(v,w,M,O,o,a,this.baseModel.outputStride,s,p,e.scoreThreshold,e.refineSteps,e.minKeypointScore,e.maxDetections)];case 2:return _=A.sent(),h.dispose(),v.dispose(),w.dispose(),y.dispose(),b.dispose(),S.dispose(),x.dispose(),M.dispose(),[2,_]}}))}))},t.prototype.dispose=function(){this.baseModel.dispose();},t}();function Xt(e){return D(this,void 0,void 0,(function(){var n,r,i,o,a,s;return B(this,(function(u){switch(u.label){case 0:if(n=e.outputStride,r=e.quantBytes,i=e.multiplier,null==tf__namespace)throw new Error("Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\n        model.");return o=function(t,e,n){var r={1:"100",.75:"075",.5:"050"},i="model-stride"+t+".json";return 4===n?It+"float/"+r[e]+"/"+i:It+"quant"+n+"/"+r[e]+"/"+i}(n,i,r),[4,tfconv.loadGraphModel(e.modelUrl||o)];case 1:return a=u.sent(),s=new Y(a,n),[2,new Qt(s)]}}))}))}function Yt(e){return D(this,void 0,void 0,(function(){var n,r,i,o,a;return B(this,(function(s){switch(s.label){case 0:if(n=e.outputStride,r=e.quantBytes,null==tf__namespace)throw new Error("Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\n        model.");return i=function(t,e){var n="model-stride"+t+".json";return 4===e?Pt+"float/"+n:Pt+"quant"+e+"/"+n}(n,r),[4,tfconv.loadGraphModel(e.modelUrl||i)];case 1:return o=s.sent(),a=new Tt(o,n),[2,new Qt(a)]}}))}))}function Gt(t){return void 0===t&&(t=Lt),D(this,void 0,void 0,(function(){return B(this,(function(e){return "ResNet50"===(t=function(t){if(null==(t=t||Lt).architecture&&(t.architecture="MobileNetV1"),zt.indexOf(t.architecture)<0)throw new Error("Invalid architecture "+t.architecture+". Should be one of "+zt);if(null==t.outputStride&&(t.outputStride=16),Wt[t.architecture].indexOf(t.outputStride)<0)throw new Error("Invalid outputStride "+t.outputStride+". Should be one of "+Wt[t.architecture]+" for architecture "+t.architecture+".");if(null==t.multiplier&&(t.multiplier=1),jt[t.architecture].indexOf(t.multiplier)<0)throw new Error("Invalid multiplier "+t.multiplier+". Should be one of "+jt[t.architecture]+" for architecture "+t.architecture+".");if(null==t.quantBytes&&(t.quantBytes=4),Vt.indexOf(t.quantBytes)<0)throw new Error("Invalid quantBytes "+t.quantBytes+". Should be one of "+Vt+" for architecture "+t.architecture+".");return t}(t)).architecture?[2,Yt(t)]:"MobileNetV1"===t.architecture?[2,Xt(t)]:[2,null]}))}))}var $t=["left_face","right_face","left_upper_arm_front","left_upper_arm_back","right_upper_arm_front","right_upper_arm_back","left_lower_arm_front","left_lower_arm_back","right_lower_arm_front","right_lower_arm_back","left_hand","right_hand","torso_front","torso_back","left_upper_leg_front","left_upper_leg_back","right_upper_leg_front","right_upper_leg_back","left_lower_leg_front","left_lower_leg_back","right_lower_leg_front","right_lower_leg_back","left_feet","right_feet"],Jt=function(){function t(t){this.mask=t;}return t.prototype.toCanvasImageSource=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,z(this.mask)]}))}))},t.prototype.toImageData=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,this.mask]}))}))},t.prototype.toTensor=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,j(this.mask)]}))}))},t.prototype.getUnderlyingType=function(){return "imagedata"},t}();function Zt(t){if(V(t),255!==t)throw new Error("Foreground id must be 255 but got "+t);return "person"}function te(t){if(V(t),t>=$t.length)throw new Error("Invalid body part value "+t);return $t[t]}var ee=function(){function t(t){this.bodyPixModel=t;}return t.prototype.segmentPeople=function(t,e){return D(this,void 0,void 0,(function(){var n,r,i,o;return B(this,(function(a){switch(a.label){case 0:return t instanceof ImageBitmap&&((n=document.createElement("canvas")).getContext("2d").drawImage(t,0,0),t=n),e.segmentBodyParts?e.multiSegmentation?[4,this.bodyPixModel.segmentMultiPersonParts(t,e)]:[3,2]:[3,5];case 1:return i=a.sent(),[3,4];case 2:return [4,this.bodyPixModel.segmentPersonParts(t,e)];case 3:i=[a.sent()],a.label=4;case 4:return r=i.map((function(t){var e=t.data,n=t.width,r=t.height,i=new Uint8ClampedArray(n*r*4).fill(0);return e.forEach((function(t,e){-1===t?(i[4*e]=$t.length,i[4*e+3]=0):(i[4*e]=t,i[4*e+3]=255);})),{maskValueToLabel:te,mask:new Jt(new ImageData(i,n,r))}})),[3,10];case 5:return e.multiSegmentation?[4,this.bodyPixModel.segmentMultiPerson(t,e)]:[3,7];case 6:return o=a.sent(),[3,9];case 7:return [4,this.bodyPixModel.segmentPerson(t,e)];case 8:o=[a.sent()],a.label=9;case 9:r=o.map((function(t){var e=t.data,n=t.width,r=t.height,i=new Uint8ClampedArray(n*r*4).fill(0);return e.forEach((function(t,e){0===t?(i[4*e]=0,i[4*e+3]=0):(i[4*e]=255,i[4*e+3]=255);})),{maskValueToLabel:Zt,mask:new Jt(new ImageData(i,n,r))}})),a.label=10;case 10:return [2,r]}}))}))},t.prototype.dispose=function(){this.bodyPixModel.dispose();},t.prototype.reset=function(){},t}();function ne(t){return D(this,void 0,void 0,(function(){return B(this,(function(e){return [2,Gt(t).then((function(t){return new ee(t)}))]}))}))}var re={runtime:"mediapipe",modelType:"general"};var ie=function(){function t(t){this.mask=t;}return t.prototype.toCanvasImageSource=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,this.mask]}))}))},t.prototype.toImageData=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,W(this.mask)]}))}))},t.prototype.toTensor=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,j(this.mask)]}))}))},t.prototype.getUnderlyingType=function(){return "canvasimagesource"},t}();function oe(t){return V(t),"person"}var ae=function(){function t(t){var e,n=this;if(this.selfieMode=!1,this.selfieSegmentationSolution=new selfie_segmentation.SelfieSegmentation({locateFile:function(e,n){return t.solutionPath?t.solutionPath.replace(/\/+$/,"")+"/"+e:n+"/"+e}}),"landscape"===t.modelType)e=1;else e=0;this.selfieSegmentationSolution.setOptions({modelSelection:e,selfieMode:this.selfieMode}),this.selfieSegmentationSolution.onResults((function(t){n.segmentation=[{maskValueToLabel:oe,mask:new ie(t.segmentationMask)}];}));}return t.prototype.segmentPeople=function(t,r){return D(this,void 0,void 0,(function(){var i,o;return B(this,(function(a){switch(a.label){case 0:return r&&r.flipHorizontal&&r.flipHorizontal!==this.selfieMode&&(this.selfieMode=r.flipHorizontal,this.selfieSegmentationSolution.setOptions({selfieMode:this.selfieMode})),t instanceof tf.Tensor?(o=ImageData.bind,[4,tf.browser.toPixels(t)]):[3,2];case 1:return i=new(o.apply(ImageData,[void 0,a.sent(),t.shape[1],t.shape[0]])),[3,3];case 2:i=t,a.label=3;case 3:return t=i,[4,this.selfieSegmentationSolution.send({image:t})];case 4:return a.sent(),[2,this.segmentation]}}))}))},t.prototype.dispose=function(){this.selfieSegmentationSolution.close();},t.prototype.reset=function(){this.selfieSegmentationSolution.reset(),this.segmentation=null,this.selfieMode=!1;},t.prototype.initialize=function(){return this.selfieSegmentationSolution.initialize()},t}();function se(t){return D(this,void 0,void 0,(function(){var e,n;return B(this,(function(r){switch(r.label){case 0:return e=function(t){if(null==t)return C({},re);var e=C({},t);return e.runtime="mediapipe",null==e.modelType&&(e.modelType=re.modelType),e}(t),[4,(n=new ae(e)).initialize()];case 1:return r.sent(),[2,n]}}))}))}function ue(t,e,n,r){var i=t.width,o=t.height,a=r?-1:1,s=Math.cos(t.rotation),u=Math.sin(t.rotation),f=t.xCenter,l=t.yCenter,c=1/e,d=1/n,h=new Array(16);return h[0]=i*s*a*c,h[1]=-o*u*c,h[2]=0,h[3]=(-.5*i*s*a+.5*o*u+f)*c,h[4]=i*u*a*d,h[5]=o*s*d,h[6]=0,h[7]=(-.5*o*s-.5*i*u*a+l)*d,h[8]=0,h[9]=0,h[10]=i*c,h[11]=0,h[12]=0,h[13]=0,h[14]=0,h[15]=1,function(t){if(16!==t.length)throw new Error("Array length must be 16 but got "+t.length);return [[t[0],t[1],t[2],t[3]],[t[4],t[5],t[6],t[7]],[t[8],t[9],t[10],t[11]],[t[12],t[13],t[14],t[15]]]}(h)}function fe(t){return t instanceof tf.Tensor?{height:t.shape[0],width:t.shape[1]}:{height:t.height,width:t.width}}function le(t,e){tf.util.assert(0!==t.width,(function(){return e+" width cannot be 0."})),tf.util.assert(0!==t.height,(function(){return e+" height cannot be 0."}));}function ce(t,e){var n=function(t,e,n,r){var i=e-t,o=r-n;if(0===i)throw new Error("Original min and max are both "+t+", range cannot be 0.");var a=o/i;return {scale:a,offset:n-t*a}}(0,255,e[0],e[1]);return tf.tidy((function(){return tf.add(tf.mul(t,n.scale),n.offset)}))}function de(t,o,a){var s=o.outputTensorSize,f=o.keepAspectRatio,l=o.borderMode,c=o.outputTensorFloatRange,d=fe(t),h=function(t,e){return e?{xCenter:e.xCenter*t.width,yCenter:e.yCenter*t.height,width:e.width*t.width,height:e.height*t.height,rotation:e.rotation}:{xCenter:.5*t.width,yCenter:.5*t.height,width:t.width,height:t.height,rotation:0}}(d,a),p=function(t,e,n){if(void 0===n&&(n=!1),!n)return {top:0,left:0,right:0,bottom:0};var r=e.height,i=e.width;le(e,"targetSize"),le(t,"roi");var o,a,s=r/i,u=t.height/t.width,f=0,l=0;return s>u?(o=t.width,a=t.width*s,l=(1-u/s)/2):(o=t.height/s,a=t.height,f=(1-s/u)/2),t.width=o,t.height=a,{top:l,left:f,right:f,bottom:l}}(h,s,f),m=ue(h,d.width,d.height,!1),g=tf.tidy((function(){var r,o=(r=t)instanceof tf.Tensor?r:tf.browser.fromPixels(r),a=tf.tensor2d(function(t,e,n){return le(n,"inputResolution"),[1/n.width*t[0][0]*e.width,1/n.height*t[0][1]*e.width,t[0][3]*e.width,1/n.width*t[1][0]*e.height,1/n.height*t[1][1]*e.height,t[1][3]*e.height,0,0]}(m,d,s),[1,8]),f="zero"===l?"constant":"nearest",h=tf.image.transform(tf.expandDims(tf.cast(o,"float32")),a,"bilinear",f,0,[s.height,s.width]);return null!=c?ce(h,c):h}));return {imageTensor:g,padding:p,transformationMatrix:m}}function he(t,e,n){return tf.tidy((function(){var r=tf.squeeze(t,[0]),i=r.shape[2];if(1===i){var o=r;switch(e.activation){case"none":break;case"sigmoid":o=tf.sigmoid(o);break;case"softmax":throw new Error("Softmax activation requires two channels.");default:throw new Error("Activation not supported ("+e.activation+")")}var a=n?tf.image.resizeBilinear(o,[n.height,n.width]):o;return tf.squeeze(a,[2])}throw new Error("Unsupported number of tensor channels "+i)}))}var pe={runtime:"tfjs",modelType:"general",modelUrl:"https://tfhub.dev/mediapipe/tfjs-model/selfie_segmentation/general/1"},me={flipHorizontal:!1},ge={outputTensorSize:{width:256,height:256},keepAspectRatio:!1,borderMode:"zero",outputTensorFloatRange:[0,1]},ve={outputTensorSize:{width:256,height:144},keepAspectRatio:!1,borderMode:"zero",outputTensorFloatRange:[0,1]},we={activation:"none"};var ye=function(){function t(t){this.mask=t;}return t.prototype.toCanvasImageSource=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,z(this.mask)]}))}))},t.prototype.toImageData=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,W(this.mask)]}))}))},t.prototype.toTensor=function(){return D(this,void 0,void 0,(function(){return B(this,(function(t){return [2,this.mask]}))}))},t.prototype.getUnderlyingType=function(){return "tensor"},t}();function be(t){return V(t),"person"}var Se,xe=function(){function t(t,e){this.modelType=t,this.model=e;}return t.prototype.segmentPeople=function(t,e){return D(this,void 0,void 0,(function(){var n,i=this;return B(this,(function(o){return e=function(t){if(null==t)return C({},me);var e=C({},t);return null==e.flipHorizontal&&(e.flipHorizontal=me.flipHorizontal),e}(e),null==t?(this.reset(),[2,[]]):(n=tf.tidy((function(){var e=de(t,"general"===i.modelType?ge:ve).imageTensor,n=tf.slice(i.model.predict(e),[0,0,0,1],-1),r=fe(t),o=he(n,we,r),a=tf.expandDims(o,2),s=tf.pad(a,[[0,0],[0,0],[0,1]]);return tf.mirrorPad(s,[[0,0],[0,0],[0,2]],"symmetric")})),[2,[{maskValueToLabel:be,mask:new ye(n)}]])}))}))},t.prototype.dispose=function(){this.model.dispose();},t.prototype.reset=function(){},t}();function Me(t){return D(this,void 0,void 0,(function(){var e,n,r;return B(this,(function(i){switch(i.label){case 0:return e=function(t){if(null==t)return C({},pe);var e=C({},t);if(e.runtime="tfjs",null==e.modelType&&(e.modelType=pe.modelType),"general"!==e.modelType&&"landscape"!==e.modelType)throw new Error("Model type must be one of general or landscape, but got "+e.modelType);null==e.modelUrl&&("general"===e.modelType?e.modelUrl="https://tfhub.dev/mediapipe/tfjs-model/selfie_segmentation/general/1":e.modelUrl="https://tfhub.dev/mediapipe/tfjs-model/selfie_segmentation/landscape/1");return e}(t),n="string"==typeof e.modelUrl&&e.modelUrl.indexOf("https://tfhub.dev")>-1,[4,tfconv.loadGraphModel(e.modelUrl,{fromTFHub:n})];case 1:return r=i.sent(),[2,new xe(e.modelType,r)]}}))}))}function ke(t,e){return D(this,void 0,void 0,(function(){var n,r;return B(this,(function(i){switch(t){case Se.MediaPipeSelfieSegmentation:if(n=void 0,null!=(r=e)){if("tfjs"===r.runtime)return [2,Me(r)];if("mediapipe"===r.runtime)return [2,se(r)];n=r.runtime;}throw new Error("Expect modelConfig.runtime to be either 'tfjs' or 'mediapipe', but got "+n);case Se.BodyPix:return [2,ne(r=e)];default:throw new Error(t+" is not a supported model name.")}}))}))}!function(t){t.BodyPix="BodyPix",t.MediaPipeSelfieSegmentation="MediaPipeSelfieSegmentation";}(Se||(Se={}));

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * https://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * Transform value ranges.
     * @param fromMin Min of original value range.
     * @param fromMax Max of original value range.
     * @param toMin New min of transformed value range.
     * @param toMax New max of transformed value range.
     */
    function transformValueRange(fromMin, fromMax, toMin, toMax) {
        var fromRange = fromMax - fromMin;
        var toRange = toMax - toMin;
        if (fromRange === 0) {
            throw new Error("Original min and max are both " + fromMin + ", range cannot be 0.");
        }
        var scale = toRange / fromRange;
        var offset = toMin - fromMin * scale;
        return { scale: scale, offset: offset };
    }
    /**
     * Convert an image to an image tensor representation.
     *
     * The image tensor has a shape [1, height, width, colorChannel].
     *
     * @param input An image, video frame, or image tensor.
     */
    function toImageTensor(input) {
        return input instanceof tf__namespace.Tensor ? input : tf__namespace.browser.fromPixels(input);
    }

    function toNumber(value) {
        return value instanceof SVGAnimatedLength ? value.baseVal.value : value;
    }
    /**
     * Converts input image to an HTMLCanvasElement. Note that converting
     * back from the output of this function to imageData or a Tensor will be lossy
     * due to premultiplied alpha color values. For more details please reference:
     * https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/putImageData#data_loss_due_to_browser_optimization
     * @param image Input image.
     *
     * @returns Converted HTMLCanvasElement.
     */
    function toHTMLCanvasElementLossy(image) {
        return __awaiter(this, void 0, void 0, function () {
            var canvas, ctx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        canvas = document.createElement('canvas');
                        if (!(image instanceof tf__namespace.Tensor)) return [3 /*break*/, 2];
                        return [4 /*yield*/, tf__namespace.browser.toPixels(image, canvas)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        canvas.width = toNumber(image.width);
                        canvas.height = toNumber(image.height);
                        ctx = canvas.getContext('2d');
                        if (image instanceof ImageData) {
                            ctx.putImageData(image, 0, 0);
                        }
                        else {
                            ctx.drawImage(image, 0, 0);
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/, canvas];
                }
            });
        });
    }

    /**
     * A calculator for changing the background of an image to black based on
     * results of segmentation returned by bodySegmentation package.
     * @param image Input image.
     * @param segmentation Segmentation mask of foreground/background.
     *
     * @returns Masked image.
     */
    function segmentForeground(image, segmentation) {
        if (tf__namespace.getBackend() === 'webgl') {
            // Same as implementation in the else case but in one custom shader on GPU.
            return segmentForegroundWebGL(image, segmentation);
        }
        // tf.tidy is unnecessary since this function is called within a tf.tidy
        // context.
        var _a = image.shape, height = _a[0], width = _a[1], channels = _a[2];
        // Extract red channel which stores probability
        var probability = tf__namespace.slice(segmentation, 0, [height, width, 1]);
        // Round to make a binary mask that can be multiplied with image.
        var binaryMask = tf__namespace.round(probability);
        // Make the same shape as input image.
        var imageBinaryMask = tf__namespace.tile(binaryMask, [1, 1, channels]);
        return tf__namespace.mul(image, imageBinaryMask);
    }
    function segmentForegroundWebGL(image, segmentation) {
        var program = {
            variableNames: ['image', 'segmentation'],
            outputShape: image.shape,
            userCode: "\n  void main() {\n      ivec3 coords = getOutputCoords();\n      int height = coords[0];\n      int width = coords[1];\n      int channel = coords[2];\n      float value = getImage(height, width, channel);\n      float foregroundProbability = getSegmentation(height, width, 0);\n      setOutput(foregroundProbability >= 0.5 ? value : 0.0);\n    }\n"
        };
        var webglBackend = tf__namespace.backend();
        var outputTensorInfo = webglBackend.compileAndRun(program, [image, segmentation]);
        return tf__namespace.engine().makeTensorFromDataId(outputTensorInfo.dataId, outputTensorInfo.shape, outputTensorInfo.dtype);
    }

    var DEFAULT_AR_PORTRAIT_DEPTH_MODEL_URL = 'https://tfhub.dev/tensorflow/tfjs-model/ar_portrait_depth/1';
    var DEFAULT_AR_PORTRAIT_DEPTH_MODEL_CONFIG = {
        depthModelUrl: DEFAULT_AR_PORTRAIT_DEPTH_MODEL_URL,
    };
    var DEFAULT_AR_PORTRAIT_DEPTH_ESTIMATION_CONFIG = {
        flipHorizontal: false,
    };

    /**
     * @license
     * Copyright 2022 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * https://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    function validateModelConfig(modelConfig) {
        if (modelConfig == null) {
            return __assign({}, DEFAULT_AR_PORTRAIT_DEPTH_MODEL_CONFIG);
        }
        var config = __assign({}, modelConfig);
        if (config.depthModelUrl == null) {
            config.depthModelUrl = DEFAULT_AR_PORTRAIT_DEPTH_MODEL_CONFIG.depthModelUrl;
        }
        return config;
    }
    function validateEstimationConfig(estimationConfig) {
        if (estimationConfig == null || estimationConfig.minDepth == null ||
            estimationConfig.maxDepth == null) {
            throw new Error('An estimation config with ' +
                'minDepth and maxDepth set must be provided.');
        }
        if (estimationConfig.minDepth > estimationConfig.maxDepth) {
            throw new Error('minDepth must be <= maxDepth.');
        }
        var config = __assign({}, estimationConfig);
        if (config.flipHorizontal == null) {
            config.flipHorizontal =
                DEFAULT_AR_PORTRAIT_DEPTH_ESTIMATION_CONFIG.flipHorizontal;
        }
        return config;
    }

    var ARPortraitDepthMap = /** @class */ (function () {
        function ARPortraitDepthMap(depthTensor) {
            this.depthTensor = depthTensor;
        }
        ARPortraitDepthMap.prototype.toCanvasImageSource = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, toHTMLCanvasElementLossy(this.depthTensor)];
                });
            });
        };
        ARPortraitDepthMap.prototype.toArray = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.depthTensor.arraySync()];
                });
            });
        };
        ARPortraitDepthMap.prototype.toTensor = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.depthTensor];
                });
            });
        };
        ARPortraitDepthMap.prototype.getUnderlyingType = function () {
            return 'tensor';
        };
        return ARPortraitDepthMap;
    }());
    var TRANSFORM_INPUT_IMAGE = transformValueRange(0, 255, 0, 1);
    var PORTRAIT_HEIGHT = 256;
    var PORTRAIT_WIDTH = 192;
    /**
     * ARPortraitDepth estimator class.
     */
    var ARPortraitDepthEstimator = /** @class */ (function () {
        function ARPortraitDepthEstimator(segmenter, estimatorModel) {
            this.segmenter = segmenter;
            this.estimatorModel = estimatorModel;
        }
        /**
         * Estimates depth for an image or video frame.
         *
         * It returns a depth map of the same number of values as input pixels.
         *
         * @param image
         * ImageData|HTMLImageElement|HTMLCanvasElement|HTMLVideoElement The input
         * image to feed through the network.
         *
         * @param config Optional.
         *       minDepth: The minimum depth value for the model to map to 0. Any
         * smaller depth values will also get mapped to 0.
         *
         *       maxDepth`: The maximum depth value for the model to map to 1. Any
         * larger depth values will also get mapped to 1.
         *
         *       flipHorizontal: Optional. Default to false. When image data comes
         * from camera, the result has to flip horizontally.
         *
         * @return `DepthMap`.
         */
        ARPortraitDepthEstimator.prototype.estimateDepth = function (image, estimationConfig) {
            return __awaiter(this, void 0, void 0, function () {
                var config, image3d, _a, height, width, segmentations, segmentation, segmentationTensor, depthTensor;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            config = validateEstimationConfig(estimationConfig);
                            if (image == null) {
                                this.reset();
                                return [2 /*return*/, null];
                            }
                            image3d = tf__namespace.tidy(function () {
                                var imageTensor = tf__namespace.cast(toImageTensor(image), 'float32');
                                if (config.flipHorizontal) {
                                    var batchAxis = 0;
                                    imageTensor = tf__namespace.squeeze(tf__namespace.image.flipLeftRight(
                                    // tslint:disable-next-line: no-unnecessary-type-assertion
                                    tf__namespace.expandDims(imageTensor, batchAxis)), [batchAxis]);
                                }
                                return imageTensor;
                            });
                            _a = image3d.shape, height = _a[0], width = _a[1];
                            return [4 /*yield*/, this.segmenter.segmentPeople(image3d)];
                        case 1:
                            segmentations = _b.sent();
                            segmentation = segmentations[0];
                            return [4 /*yield*/, segmentation.mask.toTensor()];
                        case 2:
                            segmentationTensor = _b.sent();
                            depthTensor = tf__namespace.tidy(function () {
                                var maskedImage = segmentForeground(image3d, segmentationTensor);
                                segmentationTensor.dispose();
                                // Normalizes the values from [0, 255] to [0, 1], same ranged used
                                // during training.
                                var imageNormalized = tf__namespace.add(tf__namespace.mul(maskedImage, TRANSFORM_INPUT_IMAGE.scale), 
                                // tslint:disable-next-line: no-unnecessary-type-assertion
                                TRANSFORM_INPUT_IMAGE.offset);
                                var imageResized = tf__namespace.image.resizeBilinear(imageNormalized, [PORTRAIT_HEIGHT, PORTRAIT_WIDTH]);
                                // Shape after expansion is [1, height, width, 3].
                                var batchInput = tf__namespace.expandDims(imageResized);
                                // Depth prediction (ouput shape is [1, height, width, 1]).
                                var depth4D = _this.estimatorModel.predict(batchInput);
                                // Normalize to user requirements.
                                var depthTransform = transformValueRange(config.minDepth, config.maxDepth, 0, 1);
                                // depth4D is roughly in [0,2] range, so half the scale factor to put it
                                // in [0,1] range.
                                var scale = depthTransform.scale / 2;
                                var result = 
                                // tslint:disable-next-line: no-unnecessary-type-assertion
                                tf__namespace.add(tf__namespace.mul(depth4D, scale), depthTransform.offset);
                                // Keep in [0,1] range.
                                var resultClipped = tf__namespace.clipByValue(result, 0, 1);
                                // Rescale to original input size.
                                var resultResized = tf__namespace.image.resizeBilinear(resultClipped, [height, width]);
                                // Remove channel dimension.
                                // tslint:disable-next-line: no-unnecessary-type-assertion
                                var resultSqueezed = tf__namespace.squeeze(resultResized, [0, 3]);
                                return resultSqueezed;
                            });
                            image3d.dispose();
                            return [2 /*return*/, new ARPortraitDepthMap(depthTensor)];
                    }
                });
            });
        };
        ARPortraitDepthEstimator.prototype.dispose = function () {
            this.segmenter.dispose();
            this.estimatorModel.dispose();
        };
        ARPortraitDepthEstimator.prototype.reset = function () {
            this.segmenter.reset();
        };
        return ARPortraitDepthEstimator;
    }());
    /**
     * Loads the ARPortraitDepth model.
     *
     * @param modelConfig ModelConfig object that contains parameters for
     * the ARPortraitDepth loading process. Please find more details of each
     * parameters in the documentation of the `ARPortraitDepthModelConfig`
     * interface.
     */
    function load(modelConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var config, depthModelFromTFHub, depthModel, segmenter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = validateModelConfig(modelConfig);
                        depthModelFromTFHub = typeof config.depthModelUrl === 'string' &&
                            (config.depthModelUrl.indexOf('https://tfhub.dev') > -1);
                        return [4 /*yield*/, tfconv__namespace.loadGraphModel(config.depthModelUrl, { fromTFHub: depthModelFromTFHub })];
                    case 1:
                        depthModel = _a.sent();
                        return [4 /*yield*/, ke(Se.MediaPipeSelfieSegmentation, { runtime: 'tfjs', modelUrl: config.segmentationModelUrl })];
                    case 2:
                        segmenter = _a.sent();
                        return [2 /*return*/, new ARPortraitDepthEstimator(segmenter, depthModel)];
                }
            });
        });
    }

    exports.SupportedModels = void 0;
    (function (SupportedModels) {
        SupportedModels["ARPortraitDepth"] = "ARPortraitDepth";
    })(exports.SupportedModels || (exports.SupportedModels = {}));

    /**
     * @license
     * Copyright 2022 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * https://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * Create a depth estimator instance.
     *
     * @param model The name of the pipeline to load.
     * @param modelConfig The configuration for the pipeline to load.
     */
    function createEstimator(model, modelConfig) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (model) {
                    case exports.SupportedModels.ARPortraitDepth:
                        return [2 /*return*/, load(modelConfig)];
                    default:
                        throw new Error(model + " is not a supported model name.");
                }
            });
        });
    }

    exports.createEstimator = createEstimator;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
